'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class; // 导入全局异常处理


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactNative = require('react-native');

var _theme = require('@shoutem/theme');

var _reactI18next = require('react-i18next');

require('./core/Error');

var _I18n = require('./core/I18n');

var _I18n2 = _interopRequireDefault(_I18n);

var _Router = require('./core/Router');

var _Router2 = _interopRequireDefault(_Router);

var _Push = require('./core/Push');

var Push = _interopRequireWildcard(_Push);

var _Context = require('./core/Context');

var _Theme = require('./stores/Theme');

var _Theme2 = _interopRequireDefault(_Theme);

var _I18n3 = require('./stores/I18n');

var _I18n4 = _interopRequireDefault(_I18n3);

var _ViewPort = require('./components/ViewPort');

var _ViewPort2 = _interopRequireDefault(_ViewPort);

var _helper = require('./utils/helper');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_I18n2.default.init({
  fallbackLng: ['default'],
  ns: ['common'],
  defaultNS: 'common',
  cache: {
    enabled: true
  },
  backend: {
    store: _I18n4.default.getStore()
  }
}).changeLanguage();

// 主体化、路由，调试器

var App = (0, _helper.observer)(_class = function (_React$Component) {
  (0, _inherits3.default)(App, _React$Component);

  function App() {
    (0, _classCallCheck3.default)(this, App);

    var _this = (0, _possibleConstructorReturn3.default)(this, (App.__proto__ || (0, _getPrototypeOf2.default)(App)).call(this));

    _Context.LoadContextManager.getCurrentContext().complateLoad();
    return _this;
  }

  (0, _createClass3.default)(App, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (_reactNative.Platform.OS === 'android') {
        _reactNative.BackAndroid.addEventListener('hardwareBackPress', function () {
          console.log('go back');
          try {
            _Router2.default.goBack();
            return false;
          } catch (err) {
            console.warn(err);
          }
        });
      }

      if (_reactNative.Platform.OS === 'android' || _reactNative.Platform.OS === 'ios') {
        // 开启push
        Push.subscribe();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (_reactNative.Platform.OS === 'android' || _reactNative.Platform.OS === 'ios') {
        Push.unsubscribe();
      }

      if (_reactNative.Platform.OS === 'android') {
        _reactNative.BackAndroid.removeEventListener('hardwareBackPress');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _reactI18next.I18nextProvider,
        { i18n: _I18n2.default },
        _react2.default.createElement(
          _theme.StyleProvider,
          { style: _Theme2.default.getStore().currentTheme },
          _react2.default.createElement(
            _ViewPort2.default,
            null,
            this.props.children
          )
        )
      );
    }
  }]);
  return App;
}(_react2.default.Component)) || _class;

exports.default = App;
//# sourceMappingURL=App.js.map