'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connectPlatform = connectPlatform;
exports.sendLogs = sendLogs;
exports.loginPlatUser = loginPlatUser;
exports.loginPlatUserToken = loginPlatUserToken;
exports.findServer = findServer;

var _reactNative = require('react-native');

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _helper = require('../utils/helper');

var _Device = require('../core/Device');

var _Device2 = _interopRequireDefault(_Device);

var _Screen = require('../core/Screen');

var _Screen2 = _interopRequireDefault(_Screen);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var deviceID = _Device2.default.deviceID;

function connectPlatform() {
  return (0, _helper.fetchJson)({ url: _config2.default.platform.connection });
}

function sendLogs(data) {
  return (0, _helper.fetchJson)({
    url: _config2.default.platform.statistics,
    options: {
      method: 'POST',
      // headers: {  "Content-Type": "application/json" },
      body: data
    },
    withToken: false
  });
}

function loginPlatUser(encUsername, passwordHash) {
  return (0, _helper.fetchJson)({ url: _config2.default.platform.account + '?name=' + encUsername + '&passwordHash=' + passwordHash });
}

function loginPlatUserToken(token) {
  return (0, _helper.fetchJson)({ url: _config2.default.platform.account + '?token=' + token });
}

function findServer(id) {
  return (0, _helper.fetchJson)({ url: _config2.default.platform.server + '?id=' + id + '&did=' + deviceID + '&os=' + _reactNative.Platform.OS + '&v=' + _Device2.default.systemVersion + '&s=' + _Screen2.default.Size });
}
//# sourceMappingURL=PlatformApis.js.map