'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connectAuth = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _User = require('../stores/User');

var _User2 = _interopRequireDefault(_User);

var _NoAuth = require('./NoAuth');

var _NoAuth2 = _interopRequireDefault(_NoAuth);

var _I18n = require('../core/I18n');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var connectAuth = exports.connectAuth = function connectAuth() {
  var roles = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  return function (Route) {
    var _class, _temp2;

    return (0, _I18n.translate)('core.AuthedRoute')((_temp2 = _class = function (_React$Component) {
      (0, _inherits3.default)(AuthedRoute, _React$Component);

      function AuthedRoute() {
        var _ref;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, AuthedRoute);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = AuthedRoute.__proto__ || (0, _getPrototypeOf2.default)(AuthedRoute)).call.apply(_ref, [this].concat(args))), _this), _this.state = {}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
      }

      (0, _createClass3.default)(AuthedRoute, [{
        key: 'checkAuth',
        value: function checkAuth(props) {
          var userStore = _User2.default.getStore();
          if (userStore.user == null) {
            console.log(this.props.t('用户未登录，跳转登录...'));
            this.setState({
              noAuth: true
            });
            this.context.router.history.push('/login?redirect=' + encodeURIComponent(location.pathname));
            return;
          }
          if (!userStore.user.isInRole(roles)) {
            console.log(this.props.t('用户权限验证失败'));
            this.setState({
              noAuth: true
            });
            return;
          }
          this.setState({
            noAuth: false
          });
        }
      }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
          this.checkAuth(this.props);
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          this.checkAuth(nextProps);
        }
      }, {
        key: 'render',
        value: function render() {
          var props = this.props;
          if (this.state.noAuth) {
            return _react2.default.createElement(Route, { component: _NoAuth2.default });
          }
          return _react2.default.createElement(Route, props);
        }
      }]);
      return AuthedRoute;
    }(_react2.default.Component), _class.contextTypes = {
      router: _propTypes2.default.shape({
        history: _propTypes2.default.object.isRequired,
        route: _propTypes2.default.object.isRequired,
        staticContext: _propTypes2.default.object
      })
    }, _temp2));
  };
};
//# sourceMappingURL=AuthedRoute.js.map