'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _setImmediate2 = require('babel-runtime/core-js/set-immediate');

var _setImmediate3 = _interopRequireDefault(_setImmediate2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _desc, _value, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactNative = require('react-native');

var _coreDecorators = require('core-decorators');

var _Debug = require('../core/Debug');

var _I18n = require('../core/I18n');

var _Theme = require('../core/Theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var isDebuggingIgnored = function isDebuggingIgnored() {
  return false;
};

var DebuggingRow = function DebuggingRow(_ref) {
  var debugging = _ref.debugging,
      style = _ref.style;

  return _react2.default.createElement(
    _reactNative.View,
    { style: style.inspectorRow },
    _react2.default.createElement(
      _reactNative.TouchableHighlight,
      { activeOpacity: 0.5, style: style.inspectorRowContent, underlayColor: 'transparent' },
      _react2.default.createElement(
        _reactNative.Text,
        { style: style.inspectorRowText },
        debugging
      )
    )
  );
};

var DebuggingInspector = function DebuggingInspector(_ref2) {
  var debuggingList = _ref2.debuggingList,
      onClose = _ref2.onClose,
      onDismissAll = _ref2.onDismissAll,
      style = _ref2.style;

  var rows = [];
  debuggingList.forEach(function (debugging) {
    if (!isDebuggingIgnored(debugging)) {
      rows.push(_react2.default.createElement(DebuggingRow, { key: debugging, debugging: debugging, style: style }));
    }
  });

  var countSentence = '\u8C03\u8BD5\u4FE1\u606F ' + rows.length + ' \u6761.';

  return _react2.default.createElement(
    _reactNative.TouchableHighlight,
    { activeOpacity: 0.95, underlayColor: style.backgroundColor(0.8), style: style.inspector },
    _react2.default.createElement(
      _reactNative.View,
      { style: style.inspectorContent },
      _react2.default.createElement(
        _reactNative.View,
        { style: style.inspectorCount },
        _react2.default.createElement(
          _reactNative.Text,
          { style: style.inspectorCountText },
          countSentence
        )
      ),
      _react2.default.createElement(
        _reactNative.ScrollView,
        { style: style.inspectorList, contentContainerStyle: style.inspectorListContainer },
        rows
      ),
      _react2.default.createElement(
        _reactNative.View,
        { style: style.inspectorButtons },
        _react2.default.createElement(
          _reactNative.TouchableHighlight,
          { activeOpacity: 0.5, onPress: onClose, style: style.inspectorButton, underlayColor: 'transparent' },
          _react2.default.createElement(
            _reactNative.Text,
            { style: style.inspectorButtonText },
            '\u5173\u95ED'
          )
        ),
        _react2.default.createElement(
          _reactNative.TouchableHighlight,
          { activeOpacity: 0.5, onPress: onDismissAll, style: style.inspectorButton, underlayColor: 'transparent' },
          _react2.default.createElement(
            _reactNative.Text,
            { style: style.inspectorButtonText },
            '\u6E05\u7A7A\u6240\u6709'
          )
        )
      )
    )
  );
};

var DebugView = (_class = function (_React$Component) {
  (0, _inherits3.default)(DebugView, _React$Component);

  function DebugView(props) {
    (0, _classCallCheck3.default)(this, DebugView);

    var _this = (0, _possibleConstructorReturn3.default)(this, (DebugView.__proto__ || (0, _getPrototypeOf2.default)(DebugView)).call(this, props));

    _this.state = {
      debuggingList: _Debug.debuggingList,
      inspecting: false
    };
    return _this;
  }

  (0, _createClass3.default)(DebugView, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var scheduled = null;
      this._listener = _Debug.debuggingEmitter.addListener('debug', function (debuggingList) {
        // Use `setImmediate` because debuggings often happen during render, but
        // state cannot be set while rendering.
        scheduled = scheduled || (0, _setImmediate3.default)(function () {
          scheduled = null;
          _this2.setState({ debuggingList: debuggingList });
        });
      });
      if (!!(devOptions && devOptions.debugMode)) {
        (0, _Debug.startDebug)();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      (0, _Debug.stopDebug)();
      if (this._listener) {
        this._listener.remove();
      }
    }
  }, {
    key: 'dismissDebugging',
    value: function dismissDebugging() {
      var _state = this.state,
          inspecting = _state.inspecting,
          debuggingList = _state.debuggingList;

      debuggingList.length = 0;
      this.setState({ inspecting: false, debuggingList: debuggingList });
    }
  }, {
    key: 'disableInspecting',
    value: function disableInspecting() {
      this.setState({ inspecting: false });
    }
  }, {
    key: 'enableInspecting',
    value: function enableInspecting() {
      this.setState({ inspecting: true });
    }
  }, {
    key: 'render',
    value: function render() {
      if (!devOptions.debugMode || this.state.debuggingList.length === 0) {
        return null;
      }

      var view = this.state.inspecting ? _react2.default.createElement(DebuggingInspector, { debuggingList: this.state.debuggingList, onClose: this.disableInspecting, onDismissAll: this.dismissDebugging, style: this.props.style }) : _react2.default.createElement(
        _reactNative.View,
        { style: this.props.style.tipRow },
        _react2.default.createElement(
          _reactNative.TouchableHighlight,
          { activeOpacity: 0.5, onPress: this.enableInspecting, style: this.props.style.tipRowContent, underlayColor: 'transparent' },
          _react2.default.createElement(
            _reactNative.View,
            null,
            _react2.default.createElement(
              _reactNative.Text,
              { style: this.props.style.tipRowText, numberOfLines: 2 },
              this.state.debuggingList[this.state.debuggingList.length - 1]
            )
          )
        )
      );

      return _react2.default.createElement(
        _reactNative.View,
        { style: this.state.inspecting ? this.props.style.fullScreen : this.props.style.tip },
        view
      );
    }
  }]);
  return DebugView;
}(_react2.default.Component), (_applyDecoratedDescriptor(_class.prototype, 'dismissDebugging', [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'dismissDebugging'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'disableInspecting', [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'disableInspecting'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'enableInspecting', [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'enableInspecting'), _class.prototype)), _class);
exports.default = (0, _I18n.translate)(['core.DebugView'])((0, _Theme.connectStyle)('core.DebugView')(DebugView));
//# sourceMappingURL=DebugView.js.map