'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _dec3, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _nprogress = require('nprogress');

var _nprogress2 = _interopRequireDefault(_nprogress);

var _reactNative = require('react-native');

var _coreDecorators = require('core-decorators');

var _Spinner = require('./Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _Bundle = require('../core/Bundle');

var _Bundle2 = _interopRequireDefault(_Bundle);

var _Theme = require('../core/Theme');

var _I18n = require('../core/I18n');

var _Store = require('../core/Store');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// 模块加载等待
var ModuleLoading = (_dec = (0, _I18n.translate)('core.ModuleLoading'), _dec2 = (0, _Theme.connectStyle)('core.ModuleLoading'), _dec3 = (0, _Store.connectStore)(['systemStore']), _dec(_class = _dec2(_class = _dec3(_class = (0, _coreDecorators.autobind)(_class = function (_React$Component) {
  (0, _inherits3.default)(ModuleLoading, _React$Component);

  function ModuleLoading(props) {
    (0, _classCallCheck3.default)(this, ModuleLoading);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ModuleLoading.__proto__ || (0, _getPrototypeOf2.default)(ModuleLoading)).call(this, props));

    _this.state = {
      animating: true,
      code: 'ModuleLoading',
      taskId: 0
    };
    return _this;
  }

  (0, _createClass3.default)(ModuleLoading, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.prepare(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.bundles != this.props.bundles) {
        this.prepare(nextProps);
      }
    }
  }, {
    key: 'onPressFeed',
    value: function onPressFeed() {
      if (this.state.animating) {
        return;
      }
      this.prepare(this.props);
    }
  }, {
    key: 'showBack',
    value: function showBack() {
      this.props.history.replace('/404');
    }
  }, {
    key: 'finished',
    value: function finished(taskId) {
      this.setState({ animating: false, code: 'Success' });
      if (this.props.onComplated) {
        this.props.onComplated(this.props.bundles);
      }
      if (_reactNative.Platform.OS === 'web') {
        _nprogress2.default.done();
      }
      // try {
      //   if (!this.props.history.replace(this.props.path)) {
      //     this.setState({animating: false, code: 'ModuleRouteNotRegisterd'});
      //     this.showBack();
      //   }
      // } catch (err) {
      //   console.warn(this.props.t('GotoFailed'), err);
      //   if (this.state.taskId === taskId) {
      //     this.setState({animating: false, code: 'ModuleRouteNotRegisterd'});
      //     this.showBack();
      //   }
      // }
    }
  }, {
    key: 'loadBundle',
    value: function loadBundle(taskId) {
      var _this2 = this;

      var bundles = this.props.bundles;
      return new _promise2.default(function (resolve, reject) {
        console.log(_this2.props.t('开始加载包...'));
        _Bundle2.default.load(bundles).then(function (bundles) {
          console.log(_this2.props.t('包加载完成'));
          resolve(bundles);
        }).catch(function (err) {
          console.warn(_this2.props.t('包加载失败'), err);
          if (_this2.state.taskId === taskId) {
            _this2.setState({
              animating: false,
              code: 'Failed',
              messageErr: err
            });
            _this2.showBack();
          }
        });
      });
    }
  }, {
    key: 'handleInit',
    value: function handleInit(handlers, ns) {
      var _this3 = this;

      return new _promise2.default(function () {
        var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(resolve, reject) {
          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return _promise2.default.all(handlers);

                case 2:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, _this3);
        }));

        return function (_x, _x2) {
          return _ref.apply(this, arguments);
        };
      }());
    }
  }, {
    key: 'prepare',
    value: function prepare(props) {
      var _this4 = this;

      if (_reactNative.Platform.OS === 'web') {
        _nprogress2.default.start();
      }
      var taskId = this.state.taskId + 1;
      this.setState({
        animating: true,
        messageErr: null,
        code: 'Loading',
        taskId: taskId
      });
      this.loadBundle(taskId).then(function () {
        // 如果模块配置了初始化方法，开始调用 支持promise
        if (_this4.props.initHandler && _this4.props.initHandler.length > 0) {
          _this4.handleInit(_this4.props.initHandler, _this4.props.module.name).then(function () {
            _this4.finished(taskId);
          });
        } else {
          _this4.finished(taskId);
        }
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var message = void 0;
      if (!this.state.messageErr) {
        switch (this.state.code) {
          case 'ModuleLoading':
            message = this.props.t('正在加载，请稍后...');
            break;
          case 'Success':
            message = this.props.t('模块已加载完毕');
            break;
          case 'ModuleRouteNotRegisterd':
            message = this.props.t('模块无法打开~');
            break;
          case 'Failed':
            message = this.props.t('模块加载失败，稍后重试...');
            break;
          case 'Loading':
            message = this.props.t('正在加载，请稍后...');
            break;
        }
      }
      return _react2.default.createElement(
        _reactNative.View,
        { style: this.props.style.container },
        _reactNative.Platform.OS === 'android' || _reactNative.Platform.OS === 'ios' ? _react2.default.createElement(_reactNative.StatusBar, { hidden: false, barStyle: 'default' }) : null,
        _react2.default.createElement(_Spinner2.default, { visible: this.state.animating }),
        _react2.default.createElement(
          _reactNative.TouchableOpacity,
          { onPress: this.onPressFeed },
          _react2.default.createElement(
            _reactNative.View,
            null,
            _react2.default.createElement(
              _reactNative.Text,
              { style: this.props.style.success },
              this.state.messageErr || message
            )
          )
        )
      );
    }
  }]);
  return ModuleLoading;
}(_react2.default.Component)) || _class) || _class) || _class) || _class);
exports.default = ModuleLoading;
//# sourceMappingURL=ModuleLoading.js.map