'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _reactNative = require('react-native');

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _internal = require('../utils/internal');

var _LocalStore = require('../utils/LocalStore');

var _LocalStore2 = _interopRequireDefault(_LocalStore);

var _Context = require('./Context');

var Actions = _interopRequireWildcard(_Context);

var _Store = require('./Store');

var Store = _interopRequireWildcard(_Store);

var _Router = require('../stores/Router');

var _Router2 = _interopRequireDefault(_Router);

var _Theme = require('../stores/Theme');

var _Theme2 = _interopRequireDefault(_Theme);

var _I18n = require('../stores/I18n');

var _I18n2 = _interopRequireDefault(_I18n);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function invoke(script) {
  'use strict';

  // chrome引擎new function比eval快一倍以上

  new Function(script)();
  // eval(spscript);
}

var Bundle = function () {
  function Bundle() {
    (0, _classCallCheck3.default)(this, Bundle);
    this.installs = new _map2.default();
    this.loaded = {};
    this.initMethods = [];
    this.preloads = {};
    this.dependencies = {
      // module: {module: version}
    };
    this.cacheDisable = !!(global.devOptions && global.devOptions.cacheDisable);
  } // 全部安装项
  // 已经加载项


  (0, _createClass3.default)(Bundle, [{
    key: 'getBundle',
    value: function getBundle(name) {
      (0, _assert2.default)(name);
      return this.installs.get(name);
    }
  }, {
    key: 'getDependencies',
    value: function getDependencies(name) {
      (0, _assert2.default)(name);
      return this.dependencies[name] || {};
    }
  }, {
    key: 'getPreloads',
    value: function getPreloads(scope) {
      (0, _assert2.default)(scope);
      return this.preloads[scope] || [];
    }
  }, {
    key: '_build',
    value: function _build() {
      var _this = this;

      this.preloads = {};
      this.dependencies = {};
      this.installs.forEach(function (item) {
        var scope = item.scope;
        var preloadScope = _this.preloads[scope];
        if (!preloadScope) {
          _this.preloads[scope] = preloadScope = [];
        }
        var module = {
          name: item.name,
          version: item.version
        };
        if (item.preload) {
          preloadScope.push(module);
        }
        if (item.dependencies) {
          var deps = [];
          item.dependencies.forEach(function (dependency) {
            deps.push(module);
          });
          if (deps.length > 0) {
            _this.dependencies[item.name] = deps;
          }
        }
      });
    }

    // scope范畴，用户描述元数据的什么时候有效，如果无效需要删除

  }, {
    key: 'addMetadata',
    value: function addMetadata(scope, metadatas) {
      var _this2 = this;

      (0, _assert2.default)(scope);
      if (!metadatas || metadatas.length <= 0) {
        return;
      }

      this.removeMetadata(scope);

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        var _loop = function _loop() {
          var metadata = _step.value;

          (0, _assert2.default)(metadata);
          (0, _assert2.default)(scope);
          (0, _assert2.default)(metadata.name);
          // assert(metadata.name.startsWith(scope + '/'), '元数据必须在' + scope + '范畴内');

          _this2.installs.forEach(function (item) {
            (0, _assert2.default)(item.name !== metadata.name);
          });
        };

        for (var _iterator = (0, _getIterator3.default)(metadatas), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          _loop();
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = (0, _getIterator3.default)(metadatas), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var _metadata = _step2.value;

          this.installs.set(_metadata.name, (0, _extends3.default)({}, _metadata, {
            scope: scope
          }));
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      this._build();
    }
  }, {
    key: 'removeMetadata',
    value: function removeMetadata(scope) {
      (0, _assert2.default)(scope);
      var deletes = [];
      this.installs.forEach(function (item, key) {
        if (item.scope === scope) {
          deletes.push(key);
        }
      });
      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = (0, _getIterator3.default)(deletes), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var key = _step3.value;

          this.installs.delete(key);
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }

      if (deletes.length > 0) {
        this._build();
        return true;
      }
      return false;
    }
  }, {
    key: 'addInitMethod',
    value: function addInitMethod(ns, name, handler) {
      (0, _assert2.default)(ns);
      (0, _assert2.default)(name);
      (0, _assert2.default)(handler);
      console.log('\u6A21\u5757' + ns + '/' + name + '\u521D\u59CB\u5316\u51FD\u6570\u6CE8\u518C');
      var items = this.initMethods[ns];
      if (!items) {
        this.initMethods[ns] = items = [];
      }
      return items.push({ name: name, handler: handler });
    }
  }, {
    key: 'removeInitMethod',
    value: function removeInitMethod(ns, name) {
      (0, _assert2.default)(ns);
      // assert(name, 'name is null'); 把注册后删除的添加到删除列表中，用于刷新注册
      var items = this.initMethods[ns];
      if (!items) {
        this.initMethods[ns] = items = [];
      }
      for (var i = 0, l = items.length; i < l; i++) {
        if (!name || items[i].name === name) {
          items.splice(i, 1);
          console.log('\u6A21\u5757' + ns + '/' + name + '\u521D\u59CB\u51FD\u6570\u5220\u9664');
          break;
        }
      }
    }
  }, {
    key: 'getKeys',
    value: function getKeys(ts, itemkeys, ns, name) {
      if (itemkeys) {
        var keys = itemkeys;
        if (!Array.isArray(keys)) {
          keys = [keys];
        }
        return keys.map(function (key) {
          return ns + '.' + key;
        });
      } else {
        var store = ts[name];
        var _keys = [];
        for (var p in store) {
          if (store.hasOwnProperty(p)) {
            if (p.startsWith(ns + '.')) {
              _keys.push(p);
            }
          }
        }
        return _keys;
      }
    }
  }, {
    key: 'addNS',
    value: function addNS(obj, ns) {
      var valobj = {};
      for (var p in obj) {
        if (obj.hasOwnProperty(p)) {
          valobj[ns + '.' + p] = obj[p];
        }
      }
      return valobj;
    }
  }, {
    key: 'margeToOne',
    value: function margeToOne(list, name, obj) {
      if (!list[name]) {
        list[name] = {};
      }
      list[name] = (0, _extends3.default)({}, list[name], obj);
    }
  }, {
    key: 'exeRegister',
    value: function exeRegister(actions) {
      var _this3 = this;

      // actions.forEach((item) => {
      //   switch (item.action) {
      //     case Actions.UNREGISTER_BUNDLE:
      //       Store.unregisterStore(item.ns.join('.'));
      //       Array.from(i18nStore.getStore().locales.keys()).forEach(name => {
      //         i18nStore.getStore().removeLocale(name, this.getKeys(i18nStore.getStore().locales, null, item.ns.join('.'), name));
      //       });
      //       Array.from(themeStore.getStore().themes.keys()).forEach(name => {
      //         themeStore.getStore().removeTheme(name, this.getKeys(themeStore.getStore().themes, null, item.ns.join('.'), name));
      //       });
      //       routerStore.getStore().removeRoute(item.ns.join('/')); // todo 这个函数需要重构到这里
      //       this.removeInitMethod(item.ns.join('.'));
      //       break;
      //     case Actions.UNREGISTER_STORE:
      //       Store.unregisterStore(item.ns.concat(item.name).join('.'));
      //       break;
      //     case Actions.UNREGISTER_ROUTE:
      //       routerStore.getStore().removeRoute(item.path, item.name);
      //       break;
      //     case Actions.UNREGISTER_INITMETHOD:
      //       this.removeInitMethod(item.ns.join('.'), item.name);
      //       break;
      //     case Actions.UNREGISTER_THEME:
      //       themeStore.getStore().removeTheme(item.name, this.getKeys(themeStore.getStore().themes, item.keys, item.ns.join('.'), item.name));
      //       break;
      //     case Actions.UNREGISTER_LOCALES:
      //       i18nStore.getStore().removeLocale(item.name, this.getKeys(i18nStore.getStore().locales, item.keys, item.ns.join('.'), item.name));
      //       break;
      //   }
      // });
      // 合并更新项，减少刷新次数
      var locales = {};
      var themes = {};
      var stores = [];
      var routers = [];
      var methods = [];
      actions.forEach(function (item) {
        switch (item.action) {
          case Actions.REGISTER_LOCALES:
            _this3.margeToOne(locales, item.lang, _this3.addNS(item.locales(), item.ns));
            break;
          case Actions.REGISTER_THEME:
            _this3.margeToOne(themes, item.name, _this3.addNS(item.theme(), item.ns));
            break;
          case Actions.REGISTER_STORE:
            var store = item.Store();
            for (var aliasName in store) {
              var name = void 0;
              if (store[aliasName].name !== '_default') {
                name = store[aliasName].name;
              }
              if (!name) {
                name = aliasName;
              }
              stores.push({ name: item.ns + '.' + item.name, aliasName: aliasName,
                filter: item.filter, getStoreHandler: item.getStoreHandler,
                Class: store[aliasName] });
            }
            break;
          case Actions.REGISTER_ROUTE:
            routers.push({ path: item.path, ns: item.ns,
              name: item.name, route: item.route(), handler: item.handler });
            break;
          // case Actions.REGISTER_INITMETHOD:
          //   methods.push({ns: item.ns.join('.'), name: item.name, handler: item.handler});
          //   break;
        }
      });

      _I18n2.default.getStore().addLocale(locales);
      _Theme2.default.getStore().addTheme(themes);
      stores.forEach(function (_ref) {
        var name = _ref.name,
            aliasName = _ref.aliasName,
            filter = _ref.filter,
            getStoreHandler = _ref.getStoreHandler,
            Class = _ref.Class;
        return Store.registerStore(name, aliasName, filter, getStoreHandler)(Class);
      });
      _Router2.default.getStore().addRoute(routers);
      methods.forEach(function (_ref2) {
        var ns = _ref2.ns,
            name = _ref2.name,
            handler = _ref2.handler;
        return _this3.addInitMethod(ns, name, handler);
      });
    }
  }, {
    key: 'hasLoaded',
    value: function hasLoaded(name, version) {
      return this.loaded[name] || false;
    }
  }, {
    key: 'getDependenciesInternal',
    value: function getDependenciesInternal(item, hasloads) {
      var deps = this.getDependencies(item);
      for (var depItem in deps) {
        var hasLoad = false;
        var _iteratorNormalCompletion4 = true;
        var _didIteratorError4 = false;
        var _iteratorError4 = undefined;

        try {
          for (var _iterator4 = (0, _getIterator3.default)(hasloads), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
            var hasItem = _step4.value;

            // todo 这里还需要比较版本，版本范围不符合也不能加载
            if (depItem.name === hasItem.name) {
              hasLoad = true;
              break;
            }
          }
        } catch (err) {
          _didIteratorError4 = true;
          _iteratorError4 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion4 && _iterator4.return) {
              _iterator4.return();
            }
          } finally {
            if (_didIteratorError4) {
              throw _iteratorError4;
            }
          }
        }

        if (hasLoad) {
          break;
        }
        hasloads.push(depItem);
        this.getDependenciesInternal(depItem, hasloads);
      }
    }
  }, {
    key: 'register',
    value: function register() {
      for (var _len = arguments.length, bundles = Array(_len), _key = 0; _key < _len; _key++) {
        bundles[_key] = arguments[_key];
      }

      var items = bundles.map(function (item) {
        return typeof item === 'string' ? {
          name: item
        } : item;
      });
      var ctx = Actions.LoadContextManager.createContext();
      var _iteratorNormalCompletion5 = true;
      var _didIteratorError5 = false;
      var _iteratorError5 = undefined;

      try {
        for (var _iterator5 = (0, _getIterator3.default)(items), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
          var item = _step5.value;

          var verName = item.name;
          ctx.beginRegisterBundle(verName);
          // 自动删除之前的注册
          try {
            ctx.removeBundleRegisters();
            // console.log('require ' + verName);
            var instance = (this.require || global.require)(verName);
            if (!instance) {
              debugger;
              console.error('require ' + verName + ' bundle failed.');
            }
          } catch (err) {
            // console.log('load bundle failed.');
            console.warn(err);
          } finally {
            ctx.complteRegisterBundle();
          }
        }
      } catch (err) {
        _didIteratorError5 = true;
        _iteratorError5 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion5 && _iterator5.return) {
            _iterator5.return();
          }
        } finally {
          if (_didIteratorError5) {
            throw _iteratorError5;
          }
        }
      }

      return ctx.complateLoad();
    }
    /*
    bundles =  [{
     name : string,
      version : ?string,
      file: url string
    }]
    */

  }, {
    key: 'load',
    value: function load(bundles) {
      var _this4 = this;

      (0, _assert2.default)(bundles);
      var me = this;
      return new _promise2.default(function (resolve, reject) {
        var requestCount = bundles.length,
            successItems = [];
        var successCount = 0,
            errorCount = 0,
            loadSuccess = void 0,
            errorCode = void 0;

        var needloads = [].concat((0, _toConsumableArray3.default)(bundles));
        var _iteratorNormalCompletion6 = true;
        var _didIteratorError6 = false;
        var _iteratorError6 = undefined;

        try {
          for (var _iterator6 = (0, _getIterator3.default)(bundles), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
            var _item = _step6.value;

            me.getDependenciesInternal.bind(me)(_item, needloads);
          }
        } catch (err) {
          _didIteratorError6 = true;
          _iteratorError6 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion6 && _iterator6.return) {
              _iterator6.return();
            }
          } finally {
            if (_didIteratorError6) {
              throw _iteratorError6;
            }
          }
        }

        if (typeof _this4.onLoading === 'function') {
          var ret = _this4.onLoading(needloads);
          if (ret.ok) {
            successItems.push(ret.successItems || []);
            return;
          }
        }

        function loadBundles() {
          // 全部请求完，按照顺序加载
          var regBundles = needloads.filter(function (item) {
            return successItems.indexOf(item) > -1;
          });
          var loadSuccess = me.register.apply(me, (0, _toConsumableArray3.default)(regBundles));
          if (!loadSuccess) {
            errorCode = (0, _internal.tx)('包加载失败');
          }
          return loadSuccess;
        }

        function checkLoadResult() {
          try {
            console.log((0, _internal.tx)('包加载完成 ') + (successCount + errorCount) + '/' + requestCount);
            if (successCount + errorCount === requestCount) {
              loadBundles();
            }
          } catch (err) {
            console.warn(err && err.message ? err.message : err);
          }
          if (successCount === requestCount && loadSuccess) {
            resolve();
          } else if (successCount + errorCount === requestCount) {
            reject(errorCode);
          }
        }

        function loadDefine(itemConfig, script) {
          // 注入脚本
          if (script) {
            var vername = itemConfig.name;
            var spscript = "spdefine('" + vername + "', function(global, require, module, exports) {\nrequire=global.sprequire;" + script + "\n});";

            if (__DEV__) {
              spscript += "\n\nconsole.log('运行包" + vername + "');";
            }
            invoke(spscript);
          }

          // 不能异步加载，包有依赖关系，需要全部加载完按照顺序加载
          successItems.push(itemConfig);
          successCount++;
        }

        function requestUrl(itemConfig) {
          // const devStr = __DEV__   ? '&dev=true'   : '';
          console.log((0, _internal.tx)('获取包') + '\'' + itemConfig.name + '\'...');
          fetch(itemConfig.file).then(function (response) {
            if (response.ok) {
              return response.text();
            }
            throw new TypeError('Network request failed (' + response.status + ')');
          }).then(function (responseText) {
            console.log('' + (0, _internal.tx)('加载包') + itemConfig.name);
            loadDefine(itemConfig, responseText);
            if (itemConfig.version !== 'HEAD') {
              // 每次加载最新版不保存
              _LocalStore2.default.save({
                key: 'bundleConfig',
                id: itemConfig.name.replace(/_/, ''),
                rawData: responseText
              });
            }
            checkLoadResult();
          }).catch(function (error) {
            console.log((0, _internal.tx)('加载失败') + '\'' + itemConfig.name + '\'', itemConfig.file);
            console.warn(error);
            errorCount++;
            errorCode = (0, _internal.tx)('网络连接失败');
            checkLoadResult();
          });
        }

        if (needloads.length <= 0) {
          checkLoadResult();
          return;
        }

        // 平台下载
        _reactNative.NetInfo.isConnected.fetch().then(function (isConnected) {
          if (!isConnected) {
            // adminBundleLoaded = adminBundleLoadFailed = true;
            errorCode = (0, _internal.tx)('网络连接失败');
            errorCount = requestCount;
            checkLoadResult();
            return;
          }

          var _loop2 = function _loop2(ii) {
            var item = needloads[ii];
            // 标记已经加载，防止死循环
            var vername = item.name;
            me.loaded[vername] = true;
            if (__DEV__ || me.cacheDisable) {
              requestUrl(item);
            } else {
              console.log((0, _internal.tx)('读取包元数据'));
              _LocalStore2.default.load({
                key: 'bundleConfig',
                // 需要保存服务器地址，要不切换服务器有可能造成加载错误
                id: vername.replace(/_/g, '-')
              }).then(function (script) {
                console.log((0, _internal.tx)('包元数据加载完成'));
                loadDefine(item, script);
                checkLoadResult();
              }).catch(function (err) {
                // 没有缓冲数据会在catch中返回
                if (err && err.name !== 'NotFoundError') {
                  console.warn(err);
                }
                console.log((0, _internal.tx)('包加载成功'));
                requestUrl(item);
              });
            }
          };

          for (var ii = 0; ii < needloads.length; ii++) {
            _loop2(ii);
          }
        });
      });
    }
  }]);
  return Bundle;
}();

exports.default = new Bundle();
//# sourceMappingURL=Bundle.js.map