'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LoadContextManager = exports.LoadContext = exports.UNREGISTER_INITMETHOD = exports.REGISTER_INITMETHOD = exports.UNREGISTER_STORE = exports.REGISTER_STORE = exports.UNREGISTER_THEME = exports.REGISTER_THEME = exports.UNREGISTER_BUNDLE = exports.UNREGISTER_LOCALES = exports.REGISTER_LOCALES = exports.UNREGISTER_ROUTE = exports.REGISTER_ROUTE = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _Bundle = require('./Bundle');

var _Bundle2 = _interopRequireDefault(_Bundle);

var _internal = require('../utils/internal');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var REGISTER_ROUTE = exports.REGISTER_ROUTE = 'REGISTER_ROUTE';
var UNREGISTER_ROUTE = exports.UNREGISTER_ROUTE = 'UNREGISTER_ROUTE';
var REGISTER_LOCALES = exports.REGISTER_LOCALES = 'REGISTER_LOCALES';
var UNREGISTER_LOCALES = exports.UNREGISTER_LOCALES = 'UNREGISTER_LOCALES';
var UNREGISTER_BUNDLE = exports.UNREGISTER_BUNDLE = 'UNREGISTER_BUNDLE';
var REGISTER_THEME = exports.REGISTER_THEME = 'REGISTER_THEME';
var UNREGISTER_THEME = exports.UNREGISTER_THEME = 'UNREGISTER_THEME';
var REGISTER_STORE = exports.REGISTER_STORE = 'REGISTER_STORE';
var UNREGISTER_STORE = exports.UNREGISTER_STORE = 'UNREGISTER_STORE';
var REGISTER_INITMETHOD = exports.REGISTER_INITMETHOD = 'REGISTER_INITMETHOD';
var UNREGISTER_INITMETHOD = exports.UNREGISTER_INITMETHOD = 'UNREGISTER_INITMETHOD';

var LoadContext = function () {
  function LoadContext() {
    (0, _classCallCheck3.default)(this, LoadContext);

    this._actions = [];
  }

  // beginRegisterBundle(bundleName) {
  //   assert(bundleName, tx('BundleNameNull'));
  //   assert(bundleName.indexOf('\\') === -1, tx('BundleNameNotAllow'));
  //
  //   this._currentBundleName = bundleName;
  //   this._currentNS = bundleName.split('/');
  // }
  //
  // complteRegisterBundle() {
  //   this._currentBundleName = null;
  // }
  //
  // getCurrentBundleName() {
  //   return this._currentBundleName;
  // }
  //
  // getCurrenBundleNs() {
  //   return this._currentNS;
  // }

  // // 移除包内所有注册信息
  // removeBundleRegisters() {
  //   this._actions.push({action: UNREGISTER_BUNDLE, ns: this._currentNS});
  // }

  (0, _createClass3.default)(LoadContext, [{
    key: 'registerTheme',
    value: function registerTheme(ns, name, theme) {
      this._actions.push({ action: REGISTER_THEME, name: name, theme: theme, ns: ns });
    }

    // unregisterTheme(name, keys, ns) {
    //   this._actions.push({
    //     action: UNREGISTER_THEME,
    //     name,
    //     keys,
    //     ns: ns || this._currentBundleName
    //   });
    // }

  }, {
    key: 'registerStore',
    value: function registerStore(name, Store, filter, getStoreHandler) {
      this._actions.push({
        action: REGISTER_STORE,
        name: name,
        Store: Store,
        filter: filter,
        getStoreHandler: getStoreHandler,
        ns: this._currentNS
      });
    }

    // unregisterStore(name, keys, ns) {
    //   this._actions.push({
    //     action: UNREGISTER_STORE,
    //     name,
    //     keys,
    //     ns: ns || this._currentBundleName
    //   });
    // }

  }, {
    key: 'registerLocales',
    value: function registerLocales(lang, ns, locales) {
      this._actions.push({ action: REGISTER_LOCALES, lang: lang, locales: locales, ns: ns });
    }

    // unregisterLocales(name, ns) {
    //   this._actions.push({
    //     action: UNREGISTER_LOCALES,
    //     name,
    //     ns: ns || this._currentBundleName
    //   });
    // }

  }, {
    key: 'registerRoute',
    value: function registerRoute(ns, path, name, route, handler) {
      this._actions.push({
        action: REGISTER_ROUTE,
        ns: ns,
        path: path,
        name: name,
        route: route,
        handler: handler
      });
    }

    // removeRoute(path, name) {
    //   this._actions.push({action: UNREGISTER_ROUTE, ns: this._currentNS, path, name});
    // }

    // registerModuleInitMethod(name, handler) {
    //   this._actions.push({ action: REGISTER_INITMETHOD /*, ns: this._currentNS*/ ,
    //     name, handler });
    // }

    // removeModuleInit(name) {
    //   this._actions.push({action: UNREGISTER_INITMETHOD, ns: this._currentNS, name});
    // }

  }, {
    key: 'complateLoad',
    value: function complateLoad() {
      try {
        console.log((0, _internal.tx)('开始安装模块...'));
        _Bundle2.default.exeRegister(this._actions);
        this._actions.length = 0;
        this._isComplated = true;
        //LoadContextManager.destroyCurrentContext();
        console.log((0, _internal.tx)('安装完成'));
        return true;
      } catch (err) {
        this._isFailed = true;
        //LoadContextManager.destroyCurrentContext();
        console.log((0, _internal.tx)('安装失败'));
        console.warn(err);
        return false;
      }
    }
  }]);
  return LoadContext;
}();

var LoadContextManager = function () {
  function LoadContextManager() {
    (0, _classCallCheck3.default)(this, LoadContextManager);
  }

  (0, _createClass3.default)(LoadContextManager, null, [{
    key: 'createContext',
    value: function createContext() {
      var ctx = new LoadContext();
      this.currentContext = ctx;
      return ctx;
    }
  }, {
    key: 'getCurrentContext',
    value: function getCurrentContext() {
      if (!this.currentContext) {
        console.warn((0, _internal.tx)('包加载上下文不存在'));
        return null;
      }
      return this.currentContext;
    }
  }, {
    key: 'destroyCurrentContext',
    value: function destroyCurrentContext() {
      this.currentContext = null;
    }
  }]);
  return LoadContextManager;
}();

exports.LoadContext = LoadContext;
exports.LoadContextManager = LoadContextManager;
//# sourceMappingURL=Context.js.map