'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.debuggingList = exports.debuggingEmitter = undefined;

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

exports.startDebug = startDebug;
exports.stopDebug = stopDebug;

var _EventEmitter = require('react-native/Libraries/EventEmitter/EventEmitter');

var _EventEmitter2 = _interopRequireDefault(_EventEmitter);

var _stringifySafe = require('react-native/Libraries/Utilities/stringifySafe');

var _stringifySafe2 = _interopRequireDefault(_stringifySafe);

var _internal = require('../utils/internal');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _debuggingEmitter = new _EventEmitter2.default();
var _debuggingList = [];

function sprintf(format) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  var index = 0;
  return format.replace(/%s/g, function (match) {
    return args[index++];
  });
}

function formatMessage(format) {
  format = String(format);
  var argCount = (format.match(/%s/g) || []).length;

  for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    args[_key2 - 1] = arguments[_key2];
  }

  return [sprintf.apply(undefined, [format].concat((0, _toConsumableArray3.default)(args.slice(0, argCount))))].concat((0, _toConsumableArray3.default)(args.slice(argCount).map(_stringifySafe2.default))).join(' ');
}

function updateDebuggingMap(format) {
  for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
    args[_key3 - 1] = arguments[_key3];
  }

  var debugging = formatMessage.apply(undefined, [format].concat(args));
  _debuggingList.push(debugging);
  _debuggingEmitter.emit('debug', _debuggingList);
}

var debuggingEmitter = exports.debuggingEmitter = _debuggingEmitter;
var debuggingList = exports.debuggingList = _debuggingList;

var _console = console,
    log = _console.log,
    debug = _console.debug,
    warn = _console.warn,
    error = _console.error;
function startDebug() {
  // 用户设备启用了调试模式需要显示console信息
  console.debug = function () {
    for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
      args[_key4] = arguments[_key4];
    }

    debug.apply(console, args);
    updateDebuggingMap.apply(null, args);
  };
  console.log = function () {
    for (var _len5 = arguments.length, args = Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
      args[_key5] = arguments[_key5];
    }

    if (args[0].indexOf('is already defined!') > -1) return;
    log.apply(console, args);
    updateDebuggingMap.apply(null, args);
  };
  console.warn = function () {
    for (var _len6 = arguments.length, args = Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
      args[_key6] = arguments[_key6];
    }

    warn.apply(console, args);
    updateDebuggingMap.apply(null, args);
  };
  console.error = function () {
    for (var _len7 = arguments.length, args = Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
      args[_key7] = arguments[_key7];
    }

    error.apply(console, args);
    updateDebuggingMap.apply(null, args);
  };
  warn((0, _internal.tx)('DebugStart'));
}

function stopDebug() {
  console.error = error;
  console.warn = warn;
  console.debug = debug;
  console.log = log;
  _debuggingList.length = 0;
  warn((0, _internal.tx)('SebugStop'));
}
//# sourceMappingURL=Debug.js.map