'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HookTypes = undefined;

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _internal = require('../utils/internal');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HookTypes = exports.HookTypes = ['connectStore'];

var Hook = function () {
  function Hook() {
    (0, _classCallCheck3.default)(this, Hook);
    this._hooks = new _map2.default();
  }

  (0, _createClass3.default)(Hook, [{
    key: 'addHook',
    value: function addHook(name, handler) {
      assert(HookTypes.indexOf(name) > -1, (0, _internal.tx)('HookNameNull'));
      assert(typeof handler != 'function', (0, _internal.tx)('HookHandlerNull'));

      var hook = this._hooks.get(name);
      if (!hook) {
        hook = [];
        this._hooks.set(name, hook);
      }
      hook.push(handler);
    }
  }, {
    key: 'removeHook',
    value: function removeHook(name, handler) {
      var hook = this._hooks.get(name);
      if (!hook) {
        return;
      }
      for (var i = 0; i < hook.length; i++) {
        if (hook[i] == handler) {
          hook.splice(i, 1);
          break;
        }
      }
    }
  }, {
    key: 'hooks',
    get: function get() {
      return this._hooks;
    }
  }]);
  return Hook;
}();

exports.default = new Hook();
//# sourceMappingURL=Hook.js.map