'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

exports.translate = translate;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactNative = require('react-native');

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _i18next = require('i18next');

var _i18next2 = _interopRequireDefault(_i18next);

var _reactI18next = require('react-i18next');

var i18nextReact = _interopRequireWildcard(_reactI18next);

var _internal = require('../utils/internal');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LngDetector = void 0;

switch (_reactNative.Platform.OS) {
  case 'android':
  case 'ios':
    LngDetector = require('i18next-react-native-language-detector');
    break;
  case 'web':
    LngDetector = require('i18next-browser-languagedetector');
    break;
  case 'windows':
  case 'macos':
  default:
    console.error((0, _internal.tx)('尚未支持的平台语言'), _reactNative.Platform.OS);
}

// ********************* StoreBackend **************************

function getDefaults() {
  return { store: null };
}

var StoreBackend = function () {
  function StoreBackend(services) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    (0, _classCallCheck3.default)(this, StoreBackend);

    this.init(services, options);

    this.type = 'backend';
  }

  (0, _createClass3.default)(StoreBackend, [{
    key: 'init',
    value: function init(services) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      this.services = services;
      this.options = (0, _extends3.default)({}, getDefaults(), this.options, options);
    }
  }, {
    key: 'formatLang',
    value: function formatLang(language) {
      // zh-Hans-CN
      if (language && language.indexOf('-Hans-')) {
        language = language.replace('-Hans-', '-');
      } else if (language && language.indexOf('-Hant-')) {
        language = language.replace('-Hant-', '-');
      } else if (language && language.indexOf('-CHS-')) {
        language = language.replace('-CHS-', '-');
      } else if (language && language.indexOf('-CHT-')) {
        language = language.replace('-CHT-', '-');
      }
      return language;
    }
  }, {
    key: 'read',
    value: function read(language, namespace, callback) {
      if (!this.options.store) {
        return callback((0, _internal.tx)('StoreOptionNotSet'), false);
      }
      language = this.formatLang(language);
      try {
        callback(null, this.options.store.get(language, namespace));
      } catch (err) {
        callback(err, false);
      }
    }
  }, {
    key: 'create',
    value: function create(languages, namespace, key, fallbackValue) {
      console.warn('' + languages + (0, _internal.tx)('Lang') + namespace + (0, _internal.tx)('LangNeed') + key + (0, _internal.tx)('LangDefine'));
    }
  }]);
  return StoreBackend;
}();

StoreBackend.type = 'backend';

// ********************* MemoryCache **************************

function getDefaults() {
  return { enabled: false };
}

var MemoryCache = function () {
  function MemoryCache(services) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    (0, _classCallCheck3.default)(this, MemoryCache);

    this.init(services, options);
    this.type = 'cache';
  }

  (0, _createClass3.default)(MemoryCache, [{
    key: 'init',
    value: function init(services) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      this.services = services;
      this.options = (0, _extends3.default)({}, options, this.options, getDefaults());
    }
  }, {
    key: 'load',
    value: function load(lngs, callback) {
      callback(null, this.store);
    }
  }, {
    key: 'save',
    value: function save(store) {
      this.store = store;
    }
  }]);
  return MemoryCache;
}();

MemoryCache.type = 'cache';

// **************** config *****************************

_i18next2.default.use(MemoryCache).use(StoreBackend).use(LngDetector);

_i18next2.default.tx = function (ns, key, lng) {
  if (typeof ns === 'string') {
    ns = [ns];
  }
  return _i18next2.default.t(key, { ns: ns, lng: lng });
};

function translate(ns) {
  if (!Array.isArray(ns)) {
    ns = [ns];
  }
  return function (WarppedComponent) {
    var TranslateComponent = function (_React$Component) {
      (0, _inherits3.default)(TranslateComponent, _React$Component);

      function TranslateComponent() {
        (0, _classCallCheck3.default)(this, TranslateComponent);
        return (0, _possibleConstructorReturn3.default)(this, (TranslateComponent.__proto__ || (0, _getPrototypeOf2.default)(TranslateComponent)).apply(this, arguments));
      }

      (0, _createClass3.default)(TranslateComponent, [{
        key: 'render',
        value: function render() {
          // debugger;
          var props = this.props;
          var TranslatedComponent = void 0;
          if (this.translatedComponent) {
            TranslatedComponent = this.translatedComponent;
          } else {
            if (WarppedComponent.__module && !ns.find(function (item) {
              return item.startsWith(WarppedComponent.__module + '.');
            })) {
              ns = ns.map(function (item) {
                return WarppedComponent.__module + '.' + item;
              });
            }
            (0, _assert2.default)(ns.length > 0);
            // StoreBackend为同步加载，所以直接wait即可
            TranslatedComponent = i18nextReact.translate(ns, { wait: true })(WarppedComponent);
            this.translatedComponent = TranslatedComponent;
          }
          return _react2.default.createElement(TranslatedComponent, props);
        }
      }]);
      return TranslateComponent;
    }(_react2.default.Component);
    TranslateComponent.__module = WarppedComponent.__module;
    TranslateComponent.__version = WarppedComponent.__version;
    return TranslateComponent;
  };
}

exports.default = _i18next2.default;
//# sourceMappingURL=I18n.js.map