'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.subscribe = subscribe;
exports.unsubscribe = unsubscribe;

var _reactNative = require('react-native');

var _Message = require('../stores/Message');

var _Message2 = _interopRequireDefault(_Message);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var store = _Message2.default.getStore();
var subscriptions = [];

function subscribe() {

  subscriptions.push(_reactNative.NativeAppEventEmitter.addListener('ReceiveNotification', function (notification) {
    store.receiveMessage(notification);
    console.log(notification);
  }));

  subscriptions.push(_reactNative.NativeAppEventEmitter.addListener('OpenNotification', function (notification) {
    store.openMessage(notification);
    console.log(notification);
  }));

  subscriptions.push(_reactNative.NativeAppEventEmitter.addListener('networkDidReceiveMessage', function (message) {
    store.receiveMessage(message);
    console.log(message);
  }));
}

function unsubscribe() {
  // 千万不要忘记忘记取消订阅, 通常在componentWillUnmount函数中实现。
  subscriptions.forEach(function (subscriptions) {
    return subscriptions.remove();
  });
  subscriptions.length = 0;
}
//# sourceMappingURL=Push.js.map