'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _Context = require('./Context');

var _internal = require('../utils/internal');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_Context.LoadContextManager.createContext();

var _default = function () {
  function _default() {
    (0, _classCallCheck3.default)(this, _default);
  }

  (0, _createClass3.default)(_default, null, [{
    key: 'registerRoute',

    // static registerModuleInit(name, handler) {   assert(name, '注册初始化函数必须提供一个名字');
    //   assert(handler, '初始化函数不能为空');   try {     const ctx =
    // LoadContextManager.getCurrentContext();
    // ctx.registerModuleInitMethod(name, handler);     console.log('模块初始化函数注册完成');
    //  } catch (err) {     console.log('模块初始哈函数注册失败');     console.warn(err);   } }
    //
    // static removeModuleInit(name) {   assert(name, '删除初始化函数必须提供一个名字');   try {
    //  const ctx = LoadContextManager.getCurrentContext();
    // ctx.unregisterModuleInitHandler(name);     console.log('模块初始化函数删除完成');   }
    // catch (err) {     console.log('模块初始化函数删除失败');     console.warn(err);   } }

    value: function registerRoute(name, path, ns, route, afterBuild) {
      if (arguments.length === 3) {
        afterBuild = arguments[2];
        route = arguments[1];
        ns = arguments[0];
        path = 'portal';
        name = 'default';
      }
      if (arguments.length === 4) {
        afterBuild = arguments[3];
        route = arguments[2];
        ns = arguments[1];
        path = arguments[0];
        name = 'default';
      }

      (0, _assert2.default)(name, '路由名称未定义');
      (0, _assert2.default)(path, '路由地址未定义');
      (0, _assert2.default)(typeof route === 'function');

      // let tRoute = route; if (typeof route === 'function') {   route = route(); }
      //
      // checkRoute(route);

      var ctx = _Context.LoadContextManager.getCurrentContext();
      ctx.registerRoute(ns, path, name, route, afterBuild); // 注册原始的route，route会根据state变化时动态计算
    }
  }, {
    key: 'removeRoute',
    value: function removeRoute(name, path) {
      (0, _assert2.default)(name, '路由名称未定义');
      if (!path) {
        path = 'portal';
      }

      var ctx = _Context.LoadContextManager.getCurrentContext();
      ctx.removeRoute(path, name);
    }

    // name 参数可以是 string 但是必须提供route 可以是 route        可以是 function

  }, {
    key: 'registerRootRoute',
    value: function registerRootRoute(name, ns, route, afterBuild) {
      if (arguments.length === 3) {
        afterBuild = arguments[2];
        route = arguments[1];
        ns = arguments[0];
        name = 'default';
      }
      if (arguments.length === 2 || arguments.length === 1) {
        afterBuild = arguments[1];
        route = arguments[0];
        ns = '';
        name = 'default';
      }
      this.registerRoute(name, '/', route, afterBuild);
    }
  }, {
    key: 'registerTheme',
    value: function registerTheme(name, ns, theme) {
      if (arguments.length === 2) {
        ns = arguments[0];
        theme = arguments[1];
        name = 'default';
      }
      if (arguments.length === 1) {
        ns = '';
        theme = name;
        name = 'default';
      }
      (0, _assert2.default)(name, (0, _internal.tx)('ThemeNameNull'));
      (0, _assert2.default)(theme && typeof theme === 'function');
      var ctx = _Context.LoadContextManager.getCurrentContext();
      ctx.registerTheme(ns, name, theme);
    }
  }, {
    key: 'removeTheme',
    value: function removeTheme(name, ns) {
      (0, _assert2.default)(name, (0, _internal.tx)('ThemeNameNull'));
      if (!ns) {
        var _ctx = _Context.LoadContextManager.getCurrentContext();
        ns = _ctx.getCurrentBundleName();
      }
      var ctx = _Context.LoadContextManager.getCurrentContext();
      ctx.unregisterTheme(name, ns);
    }
  }, {
    key: 'registerLocales',
    value: function registerLocales(lang, ns, locales) {
      if (arguments.length === 1) {
        // 默认是简体中文
        locales = arguments[0];
        ns = '';
        lang = 'zh-CN';
      }
      if (arguments.length === 2) {
        // 默认是简体中文
        locales = arguments[1];
        ns = arguments[0];
        lang = 'zh-CN';
      }
      (0, _assert2.default)(locales, (0, _internal.tx)('LocalesNull'));
      (0, _assert2.default)(locales && typeof locales === 'function');
      var ctx = _Context.LoadContextManager.getCurrentContext();
      ctx.registerLocales(ns, lang, locales);
    }
  }, {
    key: 'removeLocales',
    value: function removeLocales(name, ns) {
      (0, _assert2.default)(name, (0, _internal.tx)('LocalesNameNull'));
      if (!ns) {
        var _ctx2 = _Context.LoadContextManager.getCurrentContext();
        ns = _ctx2.getCurrentBundleName();
      }
      var ctx = _Context.LoadContextManager.getCurrentContext();
      ctx.unregisterLocales(name, ns);
    }
  }, {
    key: 'registerStore',
    value: function registerStore(ns, name, Store, filter, getStoreHandler) {
      if (arguments.length === 1) {
        Store = name;
        ns = '';
        name = 'default';
      }
      (0, _assert2.default)(name);
      (0, _assert2.default)(Store && typeof Store === 'function');
      var ctx = _Context.LoadContextManager.getCurrentContext();
      ctx.registerStore(ns, name, Store, filter, getStoreHandler);
    }
  }, {
    key: 'removeStore',
    value: function removeStore(name, ns) {
      (0, _assert2.default)(name, (0, _internal.tx)('StoreNameNull'));
      if (!ns) {
        var _ctx3 = _Context.LoadContextManager.getCurrentContext();
        ns = _ctx3.getCurrentBundleName();
      }
      var ctx = _Context.LoadContextManager.getCurrentContext();
      ctx.unregisterStore(name, ns);
    }
  }]);
  return _default;
}();

exports.default = _default;
//# sourceMappingURL=Registry.js.map