'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactNative = require('react-native');

var _Dimensions$get = _reactNative.Dimensions.get('window'),
    width = _Dimensions$get.width;

var lg = 1200;
var md = 992;
var sm = 768;
var xs = 312;
var xxs = 0;

var ScreenTypes = [['lg', lg], // TV LED
['md', md], // PC MAC
['sm', sm], // PAD
['xs', xs], // 手机
['xxs', xxs]];

var Size = ScreenTypes.find(function (item) {
  return width > item[1];
})[0];

// 获取合适尺寸
var get = function get() {
  for (var _len = arguments.length, types = Array(_len), _key = 0; _key < _len; _key++) {
    types[_key] = arguments[_key];
  }

  var supportTypes = ScreenTypes.filter(function (t) {
    return types.indexOf(t[0]) > -1;
  });
  if (supportTypes.length <= 0) {
    return '';
  }
  var type = supportTypes.find(function (t) {
    return width > t[1];
  });
  if (type) {
    return type;
  }
  return '';
};

exports.default = {
  lg: lg,
  md: md,
  sm: sm,
  xs: xs,
  xxs: xxs,
  ScreenTypes: ScreenTypes,
  Size: Size,
  width: width,
  get: get
};
//# sourceMappingURL=Screen.js.map