'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Chat = exports.default = undefined;

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _socket = require('socket.io-client');

var _socket2 = _interopRequireDefault(_socket);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _internal = require('../utils/internal');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// 平台消息，例如接口扫码、支付通知等状态更新
var Message = function () {
  function Message() {
    var _this = this;

    (0, _classCallCheck3.default)(this, Message);
    this.receivers = new _map2.default();

    this.socket = _socket2.default.connect(_config2.default.platform.address);
    this.socket.on('connect', function (msg) {
      console.log(msg || (0, _internal.tx)('平台即时服务已连接'));
      _this.socket.on('disconnect', function (msg) {
        console.log(msg || (0, _internal.tx)('平台即时服务已关闭'));
      });
      _this.socket.on('message', function (msg) {
        this.receivers.forEach(function (handler) {
          return handler(msg);
        });
      });
    });
  }

  (0, _createClass3.default)(Message, [{
    key: 'send',
    value: function send(command, message) {
      if (command) {
        this.socket.emit(command, message);
      } else {
        this.socket.send(message);
      }
    }
  }, {
    key: 'receive',
    value: function receive(command, handler) {
      (0, _assert2.default)(typeof handler === 'function');
      if (this.receivers.has(command)) {
        this.receivers[command].push(handler);
      } else {
        this.receivers[command] = [handler];
      }
    }
  }, {
    key: 'close',
    value: function close(command, handler) {
      (0, _assert2.default)(typeof handler === 'function');
      var handlers = this.receivers[command];
      if (!handlers || handlers.length <= 0) {
        return;
      }
      for (var i = 0; i < handlers.length; i++) {
        if (handlers[i] === handler) {
          this.receivers[command] = handlers.splice(i, 1);
          break;
        }
      }
    }
  }]);
  return Message;
}();

// 即时通讯服务


exports.default = Message;

var Chat = exports.Chat = function () {
  function Chat() {
    var _this2 = this;

    (0, _classCallCheck3.default)(this, Chat);
    this.receivers = [];

    this.socket = _socket2.default.connect(_config2.default.platform.chat);
    this.socket.on('connect', function (msg) {
      console.log(msg || (0, _internal.tx)('即时通信服务已连接'));
      _this2.socket.on('disconnect', function (msg) {
        console.log(msg || (0, _internal.tx)('即时通信服务已关闭'));
      });
      _this2.socket.on('message', function (msg) {
        this.receivers.forEach(function (handler) {
          return handler(msg);
        });
      });
    });
  }

  // 给某个账户发送消息


  (0, _createClass3.default)(Chat, [{
    key: 'send',
    value: function send(from, to, message) {
      this.socket.emit('chat', { from: from, to: to, message: message, datetime: new Date() });
    }
  }, {
    key: 'receive',
    value: function receive(handler) {
      (0, _assert2.default)(typeof handler === 'function');
      this.receivers.push(handler);
    }
  }, {
    key: 'close',
    value: function close(handler) {
      (0, _assert2.default)(typeof handler === 'function');
      for (var i = 0; i < this.receivers.length; i++) {
        if (this.receivers[i] === handler) {
          this.receivers = this.receivers.splice(i, 1);
          break;
        }
      }
    }
  }]);
  return Chat;
}();
//# sourceMappingURL=Socket.js.map