'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.connectStyle = connectStyle;

var _theme = require('@shoutem/theme');

var themes = _interopRequireWildcard(_theme);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Theme = require('../stores/Theme');

var _Theme2 = _interopRequireDefault(_Theme);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// function findParentInstanceBundleName(ele) {
//   const parent = ele && ele._reactInternalInstance && ele._reactInternalInstance._currentElement && ele._reactInternalInstance._currentElement._owner && ele._reactInternalInstance._currentElement._owner._instance;
//   if (!parent) {
//     return null;
//   }
//   if (parent.props && parent.props.bundleName) {
//     return parent.props.bundleName;
//   } else {
//     findParentInstanceBundleName(parent);
//   }
// }

function connectTheme(themeName, styles, WrappedComponent) {
  if (!styles) {
    var _ThemeComponent = function (_React$Component) {
      (0, _inherits3.default)(_ThemeComponent, _React$Component);

      function _ThemeComponent() {
        (0, _classCallCheck3.default)(this, _ThemeComponent);
        return (0, _possibleConstructorReturn3.default)(this, (_ThemeComponent.__proto__ || (0, _getPrototypeOf2.default)(_ThemeComponent)).apply(this, arguments));
      }

      (0, _createClass3.default)(_ThemeComponent, [{
        key: 'render',
        value: function render() {
          var props = this.props;
          // 需要动态绑定主题
          var currentTheme = _Theme2.default.getStore().currentTheme;
          var themeStyle = void 0;
          if (themeName) {
            var bundleName = WrappedComponent.__module;
            if (!currentTheme[themeName]) {
              // 自动补全命名空间
              if (bundleName) {
                var bundleTheme = bundleName + '.' + themeName;
                if (currentTheme[bundleTheme]) {
                  themeName = bundleTheme;
                }
              }
            }
            // 当前的主题
            var theStyles = currentTheme[themeName] || {};
            // 系统的common
            var extStyles = currentTheme.common || {};
            // 支持包内的common
            var bcStyles = bundleName && currentTheme[bundleName + '.common'] || {};
            themeStyle = (0, _extends3.default)({}, extStyles, bcStyles, theStyles);
          } else {
            themeStyle = currentTheme.common || {};
          }
          var style = props.style,
              otherProps = (0, _objectWithoutProperties3.default)(props, ['style']);

          return _react2.default.createElement(
            WrappedComponent,
            (0, _extends3.default)({}, otherProps, {
              style: (0, _extends3.default)({}, themeStyle, style) }),
            props.children
          );
        }
      }]);
      return _ThemeComponent;
    }(_react2.default.Component);
    _ThemeComponent.__module = WrappedComponent.__module;
    return _ThemeComponent;
  }
  var ThemeComponent = themes.connectStyle(themeName, styles)(WrappedComponent);
  ThemeComponent.__module = WrappedComponent.__module;
  ThemeComponent.__version = WrappedComponent.__version;
  return ThemeComponent;
}

function connectStyle(themeName) {
  var styles = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

  if (typeof themeName === 'string') {
    return function (WrappedComponent) {
      return connectTheme(themeName, styles, WrappedComponent);
    };
  } else {
    return connectTheme('common', styles, themeName);
  }
}
//# sourceMappingURL=Theme.js.map