'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _reactNative = require('react-native');

var _helper = require('./utils/helper');

var helper = _interopRequireWildcard(_helper);

var _Asset = require('./utils/Asset');

var Asset = _interopRequireWildcard(_Asset);

var _Statistics = require('./utils/Statistics');

var _Statistics2 = _interopRequireDefault(_Statistics);

var _LocalStore = require('./utils/LocalStore');

var _LocalStore2 = _interopRequireDefault(_LocalStore);

var _Bundle = require('./core/Bundle');

var _Bundle2 = _interopRequireDefault(_Bundle);

var _Registry = require('./core/Registry');

var _Registry2 = _interopRequireDefault(_Registry);

var _Theme = require('./core/Theme');

var Theme = _interopRequireWildcard(_Theme);

var _I18n = require('./core/I18n');

var _I18n2 = _interopRequireDefault(_I18n);

var _Store = require('./core/Store');

var Store = _interopRequireWildcard(_Store);

var _Socket = require('./core/Socket');

var Socket = _interopRequireWildcard(_Socket);

var _Screen = require('./core/Screen');

var _Screen2 = _interopRequireDefault(_Screen);

var _CommandBus = require('./fx/CommandBus');

var _CommandBus2 = _interopRequireDefault(_CommandBus);

var _Query = require('./fx/Query');

var _Query2 = _interopRequireDefault(_Query);

var _User = require('./stores/User');

var _User2 = _interopRequireDefault(_User);

var _System = require('./stores/System');

var _System2 = _interopRequireDefault(_System);

var _Theme2 = require('./stores/Theme');

var _Theme3 = _interopRequireDefault(_Theme2);

var _I18n3 = require('./stores/I18n');

var _I18n4 = _interopRequireDefault(_I18n3);

var _Router = require('./stores/Router');

var _Router2 = _interopRequireDefault(_Router);

var _Message = require('./stores/Message');

var _Message2 = _interopRequireDefault(_Message);

var _Server = require('./stores/Server');

var _Server2 = _interopRequireDefault(_Server);

var _App = require('./App');

var _App2 = _interopRequireDefault(_App);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// stores


// fx
module.exports = (0, _extends3.default)({
  App: _App2.default,

  UserStore: _User2.default, // 用户参数
  SystemStore: _System2.default, // 系统参数
  ThemeStore: _Theme3.default, // 主题
  I18nStore: _I18n4.default, // 多语言
  RouterStore: _Router2.default, // 路由
  MessageStore: _Message2.default, // 消息服务
  ServerStore: _Server2.default,

  // core
  Bundle: _Bundle2.default,
  I18n: _I18n2.default,
  Theme: Theme,
  Store: Store,
  Registry: _Registry2.default, // 注册模块
  Socket: Socket, // 即时通讯
  Screen: _Screen2.default,
  Platform: _reactNative.Platform,

  // fx
  CommandBus: _CommandBus2.default,
  Query: _Query2.default,

  // utils
  Asset: Asset, // 资源
  Statistics: _Statistics2.default, // 统计报表,
  LocalStore: _LocalStore2.default }, helper);

// app


// core


// utils
//# sourceMappingURL=index.js.map