'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _desc, _value, _class, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6;

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _mobx = require('mobx');

var _Server = require('./Server');

var _Server2 = _interopRequireDefault(_Server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  (0, _defineProperty2.default)(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var UserModel = (_class = function () {
  function UserModel(store, id, name, token, roles, servers, profiles, currentServer) {
    (0, _classCallCheck3.default)(this, UserModel);

    _initDefineProp(this, 'name', _descriptor, this);

    _initDefineProp(this, 'token', _descriptor2, this);

    _initDefineProp(this, 'roles', _descriptor3, this);

    _initDefineProp(this, 'servers', _descriptor4, this);

    _initDefineProp(this, 'currentServer', _descriptor5, this);

    _initDefineProp(this, 'profiles', _descriptor6, this);

    (0, _assert2.default)(store, 'store不能为空');
    (0, _assert2.default)(id, 'id不能为空');

    this.store = store;
    this.id = id;
    this.name = name;
    this.token = token;
    this.roles = roles || [];
    this.servers = servers || [];
    this.currentServer = currentServer || null;
    this.profiles = profiles || {};
  }

  (0, _createClass3.default)(UserModel, [{
    key: 'isInRole',
    value: function isInRole() {
      var _this = this;

      for (var _len = arguments.length, roles = Array(_len), _key = 0; _key < _len; _key++) {
        roles[_key] = arguments[_key];
      }

      if (arguments.length === 1 && Array.isArray(arguments[0])) {
        roles = arguments[0];
      }
      return roles.filter(function (role) {
        return _this.roles.indexOf(role) === -1;
      }).length === 0;
    }
  }, {
    key: 'hasServerAuth',
    value: function hasServerAuth(authCode, serverIn) {
      return this.store.hasServerAuth(authCode, serverIn);
    }
  }, {
    key: 'isServerAdministrator',
    value: function isServerAdministrator(serverIn) {
      return this.store.isServerAdministrator(serverIn);
    }
  }, {
    key: 'changeServer',
    value: function changeServer(serverName) {
      return this.store.changeServer(serverName);
    }
  }, {
    key: 'logout',
    value: function logout() {
      store.logout();
    }
  }, {
    key: 'toJS',
    value: function toJS() {
      return {
        id: this.id,
        name: this.name,
        roles: this.roles,
        token: this.token,
        profiles: this.profiles,
        servers: this.servers.map(function (s) {
          return s.toJS();
        }),
        currentServer: this.currentServer
      };
    }
  }, {
    key: 'server',
    get: function get() {
      return this.servers[this.currentServer] || this.servers[0];
    }
  }], [{
    key: 'fromJS',
    value: function fromJS(store, object) {
      return new UserModel(store, object.id, object.name, object.token, object.roles, (object.servers || []).map(function (s) {
        return _Server2.default.fromJS(store, s);
      }), object.profiles, object.currentServer);
    }
  }]);
  return UserModel;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'name', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'token', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'roles', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class.prototype, 'servers', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor5 = _applyDecoratedDescriptor(_class.prototype, 'currentServer', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class.prototype, 'profiles', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _applyDecoratedDescriptor(_class.prototype, 'server', [_mobx.computed], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'server'), _class.prototype)), _class);
exports.default = UserModel;
//# sourceMappingURL=User.js.map