'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _dec, _class, _desc, _value, _class2, _descriptor;

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _mobx = require('mobx');

var _locales = require('../locales');

var _locales2 = _interopRequireDefault(_locales);

var _I18n = require('../core/I18n');

var _I18n2 = _interopRequireDefault(_I18n);

var _Store = require('../core/Store');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  (0, _defineProperty2.default)(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var I18nStore = (_dec = (0, _Store.registerStore)('i18nStore'), _dec(_class = (_class2 = function () {
  function I18nStore() {
    (0, _classCallCheck3.default)(this, I18nStore);

    _initDefineProp(this, 'locales', _descriptor, this);

    // 初始化默认的主题
    for (var name in _locales2.default) {
      if (_locales2.default.hasOwnProperty(name)) {
        var coreLocale = _locales2.default[name];
        var locale = this.locales.get(name);
        if (!locale) {
          locale = _mobx.observable.map();
          this.locales.set(name, locale);
        }
        for (var p in coreLocale) {
          if (coreLocale.hasOwnProperty(p)) {
            locale.set('core.' + p, coreLocale[p]);
          }
        }
      }
    }
  }

  (0, _createClass3.default)(I18nStore, [{
    key: 'changeLanguage',
    value: function changeLanguage(lng) {
      _I18n2.default.changeLanguage(lng);
    }
  }, {
    key: 'get',
    value: function get(language, namespace) {
      (0, _assert2.default)(language);
      (0, _assert2.default)(namespace);
      return this.locales.has(language) && this.locales.get(language).get(namespace);
    }
  }, {
    key: 'addLocale',
    value: function addLocale(language, namespace, values) {
      if ((typeof language === 'undefined' ? 'undefined' : (0, _typeof3.default)(language)) === 'object') {
        var obj = language;
        for (var lang in obj) {
          for (var ns in obj[lang]) {
            this.addLocaleItem(lang, ns, obj[lang][ns]);
          }
        }
      } else {
        this.addLocaleItem(language, namespace, values);
      }
    }
  }, {
    key: 'addLocaleItem',
    value: function addLocaleItem(language, namespace, values) {
      (0, _assert2.default)(language);
      (0, _assert2.default)(namespace);

      if (this.locales.has(language)) {
        var ns = this.locales.get(language).get(namespace);
        if (!ns) {
          ns = values;
          this.locales.get(language).set(namespace, ns);
        } else {
          for (var p in values) {
            if (values.hasOwnProperty(p)) {
              ns[p] = values[p];
            }
          }
        }
      } else {
        var lang = _mobx.observable.map();
        lang.set(namespace, values);
        this.locales.set(language, lang);
      }
    }
  }, {
    key: 'removeLocale',
    value: function removeLocale(language, namespace) {
      if (namespace && language) {
        if (this.locales.has(language) && this.locales.get(language)[namespace]) {
          delete this.locales.get(language)[namespace];
        }
      } else if (language) {
        if (this.locales.has(language)) {
          this.locales.delete(language);
        }
      }
    }
  }], [{
    key: 'getStore',
    value: function getStore() {
      if (!this._instance) {
        this._instance = new I18nStore();
      }
      return this._instance;
    }
  }]);
  return I18nStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'locales', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return new _map2.default();
  }
}), _applyDecoratedDescriptor(_class2.prototype, 'changeLanguage', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'changeLanguage'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'get', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'get'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'addLocale', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'addLocale'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'removeLocale', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'removeLocale'), _class2.prototype)), _class2)) || _class);
exports.default = I18nStore;
//# sourceMappingURL=I18n.js.map