'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _dec, _class, _desc, _value, _class2, _descriptor;

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _mobx = require('mobx');

var _Store = require('../core/Store');

var _Router = require('../core/Router');

var _Router2 = _interopRequireDefault(_Router);

var _internal = require('../utils/internal');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  (0, _defineProperty2.default)(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var RouterStore = (_dec = (0, _Store.registerStore)('routerStore'), _dec(_class = (_class2 = function () {
  function RouterStore() {
    (0, _classCallCheck3.default)(this, RouterStore);

    _initDefineProp(this, 'bundleRoutes', _descriptor, this);
  }

  (0, _createClass3.default)(RouterStore, [{
    key: 'getRoutes',
    // {path:[{ns,scope,name,route:[{path,component,...}],handler}]}

    value: function getRoutes() {
      var path = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '/';

      var routes = [];
      (this.bundleRoutes.get(path) || []).forEach(function (item) {
        routes = routes.concat(item.route.map(function (p) {
          return (0, _extends3.default)({}, p, {
            ns: item.ns,
            //version: item.version,
            path: item.parent + (0, _internal.trimEnd)((0, _internal.fixStart)(p.path, '/'), '/')
          });
        }));
      });
      return routes;
    }
  }, {
    key: 'removeRoute',
    value: function removeRoute(ns, name) {
      (0, _assert2.default)(ns);
      this.bundleRoutes.forEach(function (items, path) {
        var removes = items.filter(function (item) {
          return item.ns === ns && (!name || name === item.name);
        });
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = (0, _getIterator3.default)(removes), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var item = _step.value;

            items.splice(items.indexOf(item), 1);
            console.log((0, _internal.tx)('路由已被移除'), path, ns, name);
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      });
    }
  }, {
    key: 'clearRoutes',
    value: function clearRoutes() {
      this.bundleRoutes.clear();
      console.log((0, _internal.tx)('移除所有路由注册'));
    }
  }, {
    key: 'addRoute',
    value: function addRoute(path, ns, name, route, handler) {
      if ((typeof path === 'undefined' ? 'undefined' : (0, _typeof3.default)(path)) === 'object') {
        var obj = path;
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = (0, _getIterator3.default)(obj), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var _ref2 = _step2.value;
            var _path = _ref2.path,
                _ns = _ref2.ns,
                _name = _ref2.name,
                _route = _ref2.route,
                _handler = _ref2.handler;

            this.addRouteItem(_path, _ns, _name, _route, _handler);
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }
      } else {
        this.addRouteItem(path, ns, name, route, handler);
      }
    }
  }, {
    key: 'addRouteItem',
    value: function addRouteItem(path, ns, name, route, handler) {
      (0, _assert2.default)(path);
      (0, _assert2.default)(ns);
      (0, _assert2.default)(name);
      (0, _assert2.default)(route && route.length > 0);

      var items = this.bundleRoutes.get(path);
      if (!items) {
        // obser没用，buildroute不会观察改变
        items = (0, _mobx.observable)([]);
        //items = [];
        this.bundleRoutes.set(path, items);
      }
      items.push({
        ns: ns,
        parent: (0, _internal.trimEnd)(_Router2.default.getPath(ns) || '', '/'),
        name: name,
        route: route,
        handler: handler
      });
      console.log((0, _internal.tx)('注册路由'), path, ns, name);
    }
  }], [{
    key: 'getStore',
    value: function getStore() {
      if (!this._instance) {
        this._instance = new RouterStore();
      }
      return this._instance;
    }
  }]);
  return RouterStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'bundleRoutes', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return new _map2.default();
  }
}), _applyDecoratedDescriptor(_class2.prototype, 'removeRoute', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'removeRoute'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'clearRoutes', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'clearRoutes'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'addRoute', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'addRoute'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'addRouteItem', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'addRouteItem'), _class2.prototype)), _class2)) || _class);
exports.default = RouterStore;
//# sourceMappingURL=Router.js.map