'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11;

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _mobx = require('mobx');

var _Store = require('../core/Store');

var _Router = require('../core/Router');

var _Bundle = require('../core/Bundle');

var _Bundle2 = _interopRequireDefault(_Bundle);

var _PlatformApis = require('../apis/PlatformApis');

var apis = _interopRequireWildcard(_PlatformApis);

var _ServerApis = require('../apis/ServerApis');

var sapis = _interopRequireWildcard(_ServerApis);

var _internal = require('../utils/internal');

var _Module = require('../models/Module');

var _Module2 = _interopRequireDefault(_Module);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  (0, _defineProperty2.default)(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var ServerStore = (_dec = (0, _Store.registerStore)('serverStore'), _dec(_class = (_class2 = function () {
  function ServerStore() {
    (0, _classCallCheck3.default)(this, ServerStore);

    _initDefineProp(this, 'connectState', _descriptor, this);

    _initDefineProp(this, 'connectMessage', _descriptor2, this);

    _initDefineProp(this, 'currentServer', _descriptor3, this);

    _initDefineProp(this, 'bundleServer', _descriptor4, this);

    _initDefineProp(this, 'modules', _descriptor5, this);

    _initDefineProp(this, 'currentModule', _descriptor6, this);

    _initDefineProp(this, 'lastModule', _descriptor7, this);

    _initDefineProp(this, 'defaultModule', _descriptor8, this);

    _initDefineProp(this, 'connectServer', _descriptor9, this);

    _initDefineProp(this, 'connect', _descriptor10, this);

    _initDefineProp(this, 'open', _descriptor11, this);
  } // Finding Connecting Openning Failed  Conmplated


  (0, _createClass3.default)(ServerStore, [{
    key: 'openModule',
    value: function openModule(moduleName, viewName, options) {
      (0, _assert2.default)(moduleName);
      if (viewName && typeof viewName !== 'string') {
        viewName = null;
        options = viewName;
      }
      var module = this.modules.find(function (m) {
        return m.name === moduleName;
      });
      if (!module) {
        console.warn((0, _internal.tx)('ModuleNotExists'));
        return;
      }
      var view = module.views.find(function (v) {
        return !viewName || v.name === viewName;
      });
      if (!view) {
        console.warn((0, _internal.tx)('ViewNotExists'));
        return;
      }
      _Router.Actions.gotoAction(view.url, (0, _extends3.default)({}, options, {
        module: module,
        view: view
      }));
    }
  }, {
    key: 'saveModuleToLocal',
    value: function saveModuleToLocal() {}
  }, {
    key: 'loadModuleFromLocal',
    value: function loadModuleFromLocal() {}
  }], [{
    key: 'getStore',
    value: function getStore() {
      if (!this._instance) {
        this._instance = new ServerStore();
      }
      return this._instance;
    }
  }]);
  return ServerStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'connectState', [_mobx.observable], {
  enumerable: true,
  initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'connectMessage', [_mobx.observable], {
  enumerable: true,
  initializer: null
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'currentServer', [_mobx.observable], {
  enumerable: true,
  initializer: null
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'bundleServer', [_mobx.observable], {
  enumerable: true,
  initializer: null
}), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, 'modules', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, 'currentModule', [_mobx.observable], {
  enumerable: true,
  initializer: null
}), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, 'lastModule', [_mobx.observable], {
  enumerable: true,
  initializer: null
}), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, 'defaultModule', [_mobx.observable], {
  enumerable: true,
  initializer: null
}), _applyDecoratedDescriptor(_class2.prototype, 'openModule', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'openModule'), _class2.prototype), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, 'connectServer', [_mobx.action], {
  enumerable: true,
  initializer: function initializer() {
    var _this = this;

    return function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(id) {
        var serverConfig;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (0, _assert2.default)(id, (0, _internal.tx)('ServerIdNull'));
                _this.connectState = 'Finding';
                _context.prev = 2;
                _context.next = 5;
                return apis.findServer(id);

              case 5:
                serverConfig = _context.sent;

                console.log((0, _internal.tx)('FindServerComplated'));
                _context.next = 9;
                return _this.connect(serverConfig);

              case 9:
                _context.next = 14;
                break;

              case 11:
                _context.prev = 11;
                _context.t0 = _context['catch'](2);

                (0, _mobx.runInAction)('after fetch', function () {
                  _this.connectState = 'Failed';
                  console.log((0, _internal.tx)('FindServerFailed'));
                  _this.connectMessage = _context.t0;
                });

              case 14:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this, [[2, 11]]);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }();
  }
}), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, 'connect', [_mobx.action], {
  enumerable: true,
  initializer: function initializer() {
    var _this2 = this;

    return function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(serverConfig) {
        var server, serverInfo, _serverInfo, bundles, bundleServer, modules, serConfig, serverDebugs;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                (0, _assert2.default)(serverConfig, (0, _internal.tx)('ServerConfigNull'));

                if (serverConfig.address) {
                  _context2.next = 4;
                  break;
                }

                console.log((0, _internal.tx)('ServerAddressNull'));
                return _context2.abrupt('return');

              case 4:
                server = (0, _extends3.default)({}, serverConfig);

                delete server.bundles;
                delete server.modules;
                delete server.bundleServer;
                _this2.currentServer = server;
                _this2.connectState = 'Connecting';
                serverInfo = void 0;
                _context2.prev = 11;
                _context2.next = 14;
                return sapis.testServer();

              case 14:
                serverInfo = _context2.sent;

                console.log((0, _internal.tx)('ServerConnectComplated'));
                _context2.next = 23;
                break;

              case 18:
                _context2.prev = 18;
                _context2.t0 = _context2['catch'](11);

                console.warn((0, _internal.tx)('ServerConnectFailed'));
                (0, _mobx.runInAction)('after fetch', function () {
                  _this2.connectState = 'Failed';
                  _this2.connectMessage = _context2.t0;
                });
                return _context2.abrupt('return');

              case 23:

                // 如果不是调试模式，从平台读取安装模块
                _serverInfo = serverInfo, bundles = _serverInfo.bundles, bundleServer = _serverInfo.bundleServer, modules = _serverInfo.modules, serConfig = (0, _objectWithoutProperties3.default)(_serverInfo, ['bundles', 'bundleServer', 'modules']);
                serverDebugs = {};

                if (!!(devOptions && devOptions.debugMode)) {
                  serverDebugs = {
                    modules: modules,
                    bundles: bundles,
                    bundleServer: bundleServer
                  };
                  if (serverDebugs.modules === undefined) {
                    delete serverDebugs.modules;
                  }
                  if (serverDebugs.bundles === undefined) {
                    delete serverDebugs.bundles;
                    delete serverDebugs.bundleServer;
                  }
                }
                _context2.next = 28;
                return _this2.open((0, _extends3.default)({}, serConfig, serverConfig, serverDebugs));

              case 28:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, _this2, [[11, 18]]);
      }));

      return function (_x2) {
        return _ref2.apply(this, arguments);
      };
    }();
  }
}), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, 'open', [_mobx.action], {
  enumerable: true,
  initializer: function initializer() {
    var _this3 = this;

    return function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(server) {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                (0, _assert2.default)(server, 'server is null');
                _this3.connectState = 'Openning';
                console.log((0, _internal.tx)('ServerOpenning'));
                _Bundle2.default.removeMetadata('server');
                _Bundle2.default.addMetadata('server', server.bundles);
                console.log((0, _internal.tx)('ServerOpened'));
                (0, _mobx.runInAction)('after fetch', function () {
                  _this3.modules = (server.modules || []).map(function (json) {
                    return _Module2.default.fromJS(_this3, json);
                  });
                  if (server.defaultModule) {
                    _this3.defaultModule = _this3.modules.find(function (module) {
                      return module.id === server.defaultModule;
                    });
                  } else if (_this3.modules.length > 0) {
                    _this3.defaultModule = _this3.modules[0];
                  } else {
                    _this3.defaultModule = null;
                  }
                  _this3.loadModuleFromLocal();
                });
                _context3.prev = 7;

                _this3.bundleServer = server.bundleServer;
                _context3.next = 11;
                return _Bundle2.default.load(_Bundle2.default.getPreloads('server'), server.bundleServer);

              case 11:
                console.log((0, _internal.tx)('ServerModuleLoaded'));
                _this3.connectState = 'Complated';
                _context3.next = 20;
                break;

              case 15:
                _context3.prev = 15;
                _context3.t0 = _context3['catch'](7);

                _this3.connectState = 'Failed';
                console.warn((0, _internal.tx)('ServerModuleFailed'));
                _this3.connectMessage = _context3.t0;

              case 20:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, _this3, [[7, 15]]);
      }));

      return function (_x3) {
        return _ref3.apply(this, arguments);
      };
    }();
  }
})), _class2)) || _class);
exports.default = ServerStore;
//# sourceMappingURL=Server.js.map