'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4;

var _mobx = require('mobx');

var _Support = require('../models/Support');

var _Support2 = _interopRequireDefault(_Support);

var _Device = require('../models/Device');

var _Device2 = _interopRequireDefault(_Device);

var _Bundle = require('../core/Bundle');

var _Bundle2 = _interopRequireDefault(_Bundle);

var _internal = require('../utils/internal');

var _LocalStore = require('../utils/LocalStore');

var _LocalStore2 = _interopRequireDefault(_LocalStore);

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _Store = require('../core/Store');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  (0, _defineProperty2.default)(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

console.disableDebugging = function () {
  SystemStore.getStore().device.debug = false;
};

var SystemStore = (_dec = (0, _Store.registerStore)('systemStore'), _dec(_class = (_class2 = function () {
  function SystemStore() {
    (0, _classCallCheck3.default)(this, SystemStore);

    _initDefineProp(this, 'device', _descriptor, this);

    _initDefineProp(this, 'support', _descriptor2, this);

    _initDefineProp(this, 'options', _descriptor3, this);

    _initDefineProp(this, 'config', _descriptor4, this);
  }

  (0, _createClass3.default)(SystemStore, [{
    key: 'loadSystemOptions',
    value: function loadSystemOptions() {
      var autoLoad = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      var me = this;
      return new _promise2.default(function (resolve, reject) {
        _LocalStore2.default.load({ key: 'systemOptions' }).then(function (result) {
          console.log((0, _internal.tx)('SystemOptionLoaded'));
          if (autoLoad) {
            me.options = result;
          }
          resolve(result);
        }).catch(function (err) {
          if (err && err.name !== 'NotFoundError' && err.name !== 'ExpiredError') {
            console.log((0, _internal.tx)('SystemOptionLoadFail'));
            console.warn(err);
            reject();
          } else {
            if (autoLoad) {
              me.options = {};
            }
            resolve({});
          }
        });
      });
    }
  }, {
    key: 'saveSystemOptions',
    value: function saveSystemOptions() {
      console.log('保存系统选项');
      _LocalStore2.default.save({ key: 'systemOptions', rawData: this.options });
    }
  }, {
    key: 'setSystemOption',
    value: function setSystemOption(options) {
      this.options = (0, _extends3.default)({}, this.options, options);
      this.saveSystemOptions();
    }
  }, {
    key: 'debug',
    value: function debug() {
      var enable = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      this.device.debug = enable;
      if (this.enable && this.options) {
        // 设置调试选项
        _Bundle2.default.cacheDisable(!!this.options.cacheDisable);
      }
    }
  }], [{
    key: 'getStore',
    value: function getStore() {
      if (!this._instance) {
        this._instance = new SystemStore();
      }
      return this._instance;
    }
  }]);
  return SystemStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'device', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return new _Device2.default();
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'support', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return new _Support2.default();
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'options', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'config', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return _config2.default;
  }
}), _applyDecoratedDescriptor(_class2.prototype, 'loadSystemOptions', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'loadSystemOptions'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'saveSystemOptions', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'saveSystemOptions'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setSystemOption', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'setSystemOption'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'debug', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'debug'), _class2.prototype)), _class2)) || _class);
exports.default = SystemStore;
//# sourceMappingURL=System.js.map