'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2;

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _mobx = require('mobx');

var _themes = require('../themes');

var _themes2 = _interopRequireDefault(_themes);

var _common = require('../themes/common');

var _common2 = _interopRequireDefault(_common);

var _Store = require('../core/Store');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  (0, _defineProperty2.default)(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

function mapToObj(map) {
  var obj = {};
  map.forEach(function (item, k) {
    obj[k] = item;
  });
  return obj;
}

var ThemeStore = (_dec = (0, _Store.registerStore)('themeStore'), _dec(_class = (_class2 = function () {
  (0, _createClass3.default)(ThemeStore, [{
    key: 'createDefaultTheme',
    value: function createDefaultTheme(ns, defaultThemes) {
      for (var name in defaultThemes) {
        if (defaultThemes.hasOwnProperty(name)) {
          var coreTheme = defaultThemes[name];
          var theme = this.themes.get(name);
          if (!theme) {
            theme = _mobx.observable.map();
            this.themes.set(name, theme);
          }
          for (var p in coreTheme) {
            if (coreTheme.hasOwnProperty(p)) {
              theme.set('' + (ns ? ns + '.' : '') + p, (0, _mobx.observable)(coreTheme[p]));
            }
          }
        }
      }
    }
  }, {
    key: 'defaultTheme',
    get: function get() {
      return mapToObj(this.themes.get('default'));
    }
  }, {
    key: 'currentTheme',
    get: function get() {
      var defaultTheme = mapToObj(this.themes.get('default'));
      if (this.currentThemeName === 'default') {
        return defaultTheme;
      }
      var currentTheme = mapToObj(this.themes.get(this.currentThemeName));
      return (0, _extends3.default)({}, defaultTheme, currentTheme);
    }
  }]);

  function ThemeStore() {
    (0, _classCallCheck3.default)(this, ThemeStore);

    _initDefineProp(this, 'themes', _descriptor, this);

    _initDefineProp(this, 'currentThemeName', _descriptor2, this);

    // 初始化默认的主题
    this.createDefaultTheme('core', _themes2.default);
    this.createDefaultTheme(null, _common2.default);

    // 当前主题
    this.currentThemeName = 'default';
  }

  (0, _createClass3.default)(ThemeStore, [{
    key: 'setTheme',
    value: function setTheme(name) {
      (0, _assert2.default)(name, '主题名称未指定');
      if (!this.themes.get(name)) {
        console.warn(name + '主题不存在');
        return false;
      }
      this.currentThemeName = name;
      return true;
    }
  }, {
    key: 'addTheme',
    value: function addTheme(name, key, theme) {
      if ((typeof name === 'undefined' ? 'undefined' : (0, _typeof3.default)(name)) === 'object') {
        var obj = name;
        for (var n in obj) {
          for (var _key in obj[n]) {
            this.addThemeItem(n, _key, obj[n][_key]);
          }
        }
      } else {
        this.addThemeItem(name, key, theme);
      }
    }
  }, {
    key: 'addThemeItem',
    value: function addThemeItem(name, key, theme) {
      (0, _assert2.default)(name, '主题名称不能为空');
      (0, _assert2.default)(key, '主题命名空间不能为空');
      var theth = this.themes.get(name);
      if (!theth) {
        theth = _mobx.observable.map();
        this.themes.set(name, theth);
      }
      theth.set(key, theme);
      return true;
    }
  }, {
    key: 'removeTheme',
    value: function removeTheme(name, keys) {
      var _this = this;

      (0, _assert2.default)(name, '主题名称不能为空');
      if (!this.themes.get(name)) {
        console.warn(name + '主题不存在');
        return false;
      }
      if (!keys) {
        this.themes.delete(name);
      } else {
        if (!Array.isArray(keys)) {
          keys = [keys];
        }
        keys.forEach(function (key) {
          delete _this.themes.get(name)[key];
        });
      }
      return true;
    }
  }], [{
    key: 'getStore',
    value: function getStore() {
      if (!this._instance) {
        this._instance = new ThemeStore();
      }
      return this._instance;
    }
  }]);
  return ThemeStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'themes', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return new _map2.default();
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'currentThemeName', [_mobx.observable], {
  enumerable: true,
  initializer: null
}), _applyDecoratedDescriptor(_class2.prototype, 'defaultTheme', [_mobx.computed], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'defaultTheme'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'currentTheme', [_mobx.computed], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'currentTheme'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setTheme', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'setTheme'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'addTheme', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'addTheme'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'removeTheme', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'removeTheme'), _class2.prototype)), _class2)) || _class);
exports.default = ThemeStore;
//# sourceMappingURL=Theme.js.map