'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4;

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _sha = require('crypto-js/sha1');

var _sha2 = _interopRequireDefault(_sha);

var _mobx = require('mobx');

var _Server = require('./Server');

var _Server2 = _interopRequireDefault(_Server);

var _Router = require('./Router');

var _Router2 = _interopRequireDefault(_Router);

var _User = require('../models/User');

var _User2 = _interopRequireDefault(_User);

var _Histroy = require('../models/Histroy');

var _Histroy2 = _interopRequireDefault(_Histroy);

var _Statistics = require('../utils/Statistics');

var _Statistics2 = _interopRequireDefault(_Statistics);

var _LocalStore = require('../utils/LocalStore');

var _LocalStore2 = _interopRequireDefault(_LocalStore);

var _internal = require('../utils/internal');

var _Store = require('../core/Store');

var _PlatformApis = require('../apis/PlatformApis');

var apis = _interopRequireWildcard(_PlatformApis);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  (0, _defineProperty2.default)(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var UserStore = (_dec = (0, _Store.registerStore)('userStore'), _dec(_class = (_class2 = function () {
  function UserStore() {
    (0, _classCallCheck3.default)(this, UserStore);

    _initDefineProp(this, 'loginState', _descriptor, this);

    _initDefineProp(this, 'user', _descriptor2, this);

    _initDefineProp(this, 'historyList', _descriptor3, this);

    _initDefineProp(this, 'options', _descriptor4, this);
  }

  (0, _createClass3.default)(UserStore, [{
    key: 'getToken',
    value: function getToken() {
      return this.user && this.user.token && this.user.token.data;
    }
  }, {
    key: 'getDefaultServer',
    value: function getDefaultServer() {
      return this.user && this.user.server;
    }
  }, {
    key: 'logout',
    value: function logout() {
      // 删除之前的登录状态
      _LocalStore2.default.remove({ key: 'loginState' });
      this.user = null;
    }
  }, {
    key: 'login',
    value: function login(_ref) {
      var _this = this;

      var username = _ref.username,
          password = _ref.password,
          token = _ref.token;

      console.log((0, _internal.tx)('开始登录'));
      _Statistics2.default.log({ how: 'login' });
      return new _promise2.default(function () {
        var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(resolve, reject) {
          var user, encUsername, passwordHash, _user;

          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (!token) {
                    _context.next = 17;
                    break;
                  }

                  _Statistics2.default.log({ how: 'sso' });
                  _context.prev = 2;
                  _context.next = 5;
                  return apis.loginPlatUserToken(token);

                case 5:
                  user = _context.sent;

                  _this.changeUser(user);
                  console.log((0, _internal.tx)('登录完成'));
                  resolve(user);
                  _context.next = 15;
                  break;

                case 11:
                  _context.prev = 11;
                  _context.t0 = _context['catch'](2);

                  console.log((0, _internal.tx)('登录失败'));
                  reject(_context.t0);

                case 15:
                  _context.next = 32;
                  break;

                case 17:
                  encUsername = encodeURIComponent(username) || '';
                  passwordHash = (0, _sha2.default)(password).toString();
                  _context.prev = 19;
                  _context.next = 22;
                  return apis.loginPlatUser(encUsername, passwordHash);

                case 22:
                  _user = _context.sent;

                  _this.changeUser(_user);
                  console.log((0, _internal.tx)('登录完成'));
                  resolve(_user);
                  _context.next = 32;
                  break;

                case 28:
                  _context.prev = 28;
                  _context.t1 = _context['catch'](19);

                  console.log((0, _internal.tx)('登录失败'));
                  reject(_context.t1);

                case 32:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, _this, [[2, 11], [19, 28]]);
        }));

        return function (_x, _x2) {
          return _ref2.apply(this, arguments);
        };
      }());
    }
  }, {
    key: 'changeUser',
    value: function changeUser(user) {
      (0, _assert2.default)(user);
      (0, _assert2.default)(user.id);
      (0, _assert2.default)(user.name);
      (0, _assert2.default)(user.token);

      console.log((0, _internal.tx)('切换用户'));
      // 保持当前用户
      this.loginState = this.user = _User2.default.fromJS(this, user);

      // 更新历史用户列表
      this.saveLoginState();

      // 保持历史记录和登录状态
      this.historyList.add(this.user);
      this.saveHistoryList();
    }
  }, {
    key: 'saveLoginState',
    value: function saveLoginState() {
      if (this.user) {
        console.log('保存登陆状态');
        _LocalStore2.default.save({
          key: 'loginState',
          id: 'loginState',
          rawData: this.user.toJS(),
          expires: this.user.token && this.user.token.expires || 1000 * 3600 * 24 * 7 // 保持一周
        });
      }
    }
  }, {
    key: 'saveHistoryList',
    value: function saveHistoryList() {
      // 添加历史记录
      console.log((0, _internal.tx)('保存登陆历史记录'));
      _LocalStore2.default.save({ key: 'historyList', rawData: this.historyList.toJS() });
    }

    // 恢复最后一次登录的用户状态

  }, {
    key: 'loadLoginState',
    value: function loadLoginState() {
      var autoLogin = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      console.log((0, _internal.tx)('恢复最后一次登录的用户状态'));
      var me = this;
      return new _promise2.default(function (resolve, reject) {
        _LocalStore2.default.load({ key: 'loginState', id: 'loginState' }).then(function (result) {
          console.log((0, _internal.tx)('恢复登录状态完成'));
          if (autoLogin) {
            if (me.user) {
              me.logout();
            }
            me.login(result);
          }
          me.loginState = result;
          resolve(result);
        }).catch(function (err) {
          if (err && err.name !== 'NotFoundError' && err.name !== 'ExpiredError') {
            console.log((0, _internal.tx)('登录状态恢复失败'));
            console.warn(err);
            resolve({});
          } else {
            resolve({});
          }
        });
      });
    }
  }, {
    key: 'loadHistoryList',
    value: function loadHistoryList() {
      var autoLoad = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      console.log((0, _internal.tx)('加载登录历史记录'));
      var me = this;
      return new _promise2.default(function (resolve, reject) {
        _LocalStore2.default.load({ key: 'historyList' }).then(function (result) {
          console.log((0, _internal.tx)('加载登录历史记录完成'));
          if (autoLoad) {
            me.historyList.clear();
            (result.items || []).forEach(function (s) {
              return me.historyList.add(_User2.default.fromJS(me, s));
            });
          }
          resolve(result || []);
        }).catch(function (err) {
          if (err && err.name !== 'NotFoundError' && err.name !== 'ExpiredError') {
            console.log((0, _internal.tx)('加载登录历史记录失败'));
            console.warn(err);
            resolve();
          } else {
            resolve();
          }
        });
      });
    }

    // 恢复指定用户的选项设置

  }, {
    key: 'loadUserOptions',
    value: function loadUserOptions(name) {
      var autoUpdate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      (0, _assert2.default)(name);
      console.log('恢复用户选项', name);
      var me = this;
      return new _promise2.default(function (resolve, reject) {
        _LocalStore2.default.load({ key: 'useroptions', id: name }).then(function (result) {
          console.log((0, _internal.tx)('用户选项加载完成'));
          if (autoUpdate && me.user) {
            me.options = result;
          }
          resolve(result);
        }).catch(function (err) {
          if (err && err.name !== 'NotFoundError' && err.name !== 'ExpiredError') {
            console.log((0, _internal.tx)('用户选项加载失败'));
            console.warn(err);
            reject();
          } else {
            if (autoUpdate && me.user) {
              me.options = {};
            }
            resolve();
          }
        });
      });
    }
  }, {
    key: 'loadHistory',
    value: function loadHistory() {
      var _this2 = this;

      var autoLogin = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      this.loadLoginState(autoLogin).then(function (loginState) {
        _this2.loginState = loginState || {};
        if (loginState.name) _this2.loadUserOptions(loginState.name, true);
      });
      this.loadHistoryList();
    }
  }, {
    key: 'saveUserOptions',
    value: function saveUserOptions() {
      (0, _assert2.default)(this.user && this.user.name);
      console.log((0, _internal.tx)('保存用户选项'), this.user.name);
      _LocalStore2.default.save({ key: 'useroptions', id: this.user.name, rawData: this.options });
    }
  }, {
    key: 'setUserOption',
    value: function setUserOption(options) {
      this.options = (0, _extends3.default)({}, this.options, options);
      this.saveUserOptions();
    }

    // 是否拥有服务器指定权限，ns默认为当前模块

  }, {
    key: 'hasServerAuth',
    value: function hasServerAuth(authCode) {
      var ns = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      if (!authCode) return false;
      ns = ns || _Router2.default.getStore().currentBundle && _Router2.default.getStore().currentBundle.name;
      if (!ns) {
        console.warn((0, _internal.tx)('当前模块不存在，权限无法判定'));
        return false;
      }
      var module = bundle.getBundle(ns);
      if (!module || !module.spModule || !module.spModule.id) return false;
      var moduleID = parseInt(module.spModule.id);
      if (!moduleID) return false;
      var authID = parseInt(module.spModule.auth[authCode]);
      if (!authID) return false;
      if (authID >= 1000) {
        console.warn('auth code ' + module.name + '/' + authCode + '(' + authID + '>1000) is invalid');
      }
      var fullCode = moduleID * 1000 + authID;
      var currentServer = _Server2.default.getStore().currentServer;
      var serverAuth = currentServer && currentServer.auth;
      if (!serverAuth.scope) return false;
      var scopes = void 0;
      // 支持数据和范围
      if (!Array.isArray(serverAuth.scope)) scopes = [serverAuth.scope];else {
        scopes = serverAuth.scope;
      }
      if (!serverAuth.exclude) {
        // 包含
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = (0, _getIterator3.default)(scopes), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var scope = _step.value;

            return scope.length == 2 ? fullCode >= scope[0] && fullcode <= scope[1] : fullcode == scope;
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      } else {
        // 排除法
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = (0, _getIterator3.default)(scopes), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var scope2 = _step2.value;

            if (scope2.length == 2 ? fullCode >= scope2[0] && fullcode <= scope2[1] : fullcode == scope2) {
              return false;
            }
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }

        return true;
      }
    }

    // 是否是企业管理员

  }, {
    key: 'isServerAdministrator',
    value: function isServerAdministrator(serverIn) {
      if (!serverIn) {
        // 没有指定企业取当前所在企业服务器
        var currentServer = _Server2.default.getStore().currentServer;
        serverIn = currentServer.name;
      }
      if (!serverIn) return false;
      return this.user.isInRole('Server' + serverIn + 'Administrator') > -1;
    }
  }, {
    key: 'changeServer',
    value: function changeServer(serverName) {
      (0, _assert2.default)(server);
      if (!this.user || !this.user.servers.find(function (s) {
        return s.name == serverName;
      })) {
        return false;
      }
      this.user.currentServer = serverName;
      return true;
    }
  }, {
    key: 'relogin',
    value: function relogin() {
      var _this3 = this;

      _Statistics2.default.log({ how: 'relogin' });
      return new _promise2.default(function (resolve, reject) {
        if (!_this3.loginState.token || !_this3.loginState.name) {
          reject();
          return;
        }
        _this3.changeUser(_this3.loginState);
        console.log((0, _internal.tx)('恢复登录完成'));
        resolve(_this3.user);
      });
    }
  }], [{
    key: 'getStore',
    value: function getStore() {
      if (!this._instance) {
        this._instance = new UserStore();
      }
      return this._instance;
    }
  }]);
  return UserStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'loginState', [_mobx.observable], {
  enumerable: true,
  initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'user', [_mobx.observable], {
  enumerable: true,
  initializer: null
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'historyList', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return new _Histroy2.default();
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'options', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _applyDecoratedDescriptor(_class2.prototype, 'logout', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'logout'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'login', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'login'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'changeUser', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'changeUser'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'saveLoginState', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'saveLoginState'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'saveHistoryList', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'saveHistoryList'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'loadLoginState', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'loadLoginState'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'loadHistoryList', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'loadHistoryList'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'loadUserOptions', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'loadUserOptions'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'loadHistory', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'loadHistory'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'saveUserOptions', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'saveUserOptions'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setUserOption', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'setUserOption'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'hasServerAuth', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'hasServerAuth'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'isServerAdministrator', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'isServerAdministrator'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'changeServer', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'changeServer'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'relogin', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class2.prototype, 'relogin'), _class2.prototype)), _class2)) || _class);
exports.default = UserStore;
//# sourceMappingURL=User.js.map