'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

exports.registerAssets = registerAssets;

var _reactNative = require('react-native');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function registerAssets(assets) {
  if (assets.length <= 0) {
    return null;
  }
  var platform = _reactNative.Platform.OS;
  var scale = _reactNative.PixelRatio.get();
  var alterasset = null;
  var theasset;
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = (0, _getIterator3.default)(assets), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var asset = _step.value;

      if (!asset.platform || asset.platform === platform) {
        if (scale === asset.scale) {
          theasset = asset;
          break;
        }
        if (alterasset === null) {
          alterasset = asset;
        } else {
          var diff = Math.abs(asset.scale - scale) - Math.abs(alterasset.scale - scale);
          if (diff < 0 || diff === 0 && asset.scale > alterasset.scale) {
            // 精度差小的或相等取分辨率大的
            alterasset = asset;
          }
        }
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return (theasset || alterasset).source;
}
//# sourceMappingURL=Asset.js.map