'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _lzwcompress = require('lzwcompress');

var _lzwcompress2 = _interopRequireDefault(_lzwcompress);

var _Router = require('../stores/Router');

var _Router2 = _interopRequireDefault(_Router);

var _User = require('../stores/User');

var _User2 = _interopRequireDefault(_User);

var _internal = require('./internal');

var _PlatformApis = require('../apis/PlatformApis');

var apis = _interopRequireWildcard(_PlatformApis);

var _Device = require('../core/Device');

var _Device2 = _interopRequireDefault(_Device);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Statistics = function () {
  function Statistics() {
    var _this = this;

    (0, _classCallCheck3.default)(this, Statistics);

    this.logs = [];

    // 记录用户使用的设备
    setTimeout(function () {
      _this.log({
        how: 'use',
        what: _Device2.default.deviceId,
        systemVersion: _Device2.default.systemVersion,
        readableVersion: _Device2.default.readableVersion,
        deviceLocale: _Device2.default.deviceLocale,
        deviceCountry: _Device2.default.deviceCountry
      });
    });

    // 记录日志活动 inject(console.debug, this.logConsole.bind(this, 'debug'));  //
    // 调试信息不收集
    this.injectConsele('info');
    this.injectConsele('warn');
    this.injectConsele('error');

    // 定时发送
    this.startTimer();
  }

  (0, _createClass3.default)(Statistics, [{
    key: 'injectConsele',
    value: function injectConsele(level) {
      this.logConsole.bind(this, level);
      var oldLoger = console[level];
      var me = this;
      console[level] = function () {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        var msg = '';
        for (var i = 0; i < args.length; i++) {
          if (i !== 0) {
            msg += '\n';
          }
          msg += args[i];
        }
        if (__DEV__) {
          // 调试器bug忽略
          if (msg === 'Attempted to transition from state `RESPONDER_INACTIVE_PRESS_IN` to `RESPONDER_A' + 'CTIVE_LONG_PRESS_IN`, which is not supported. This is most likely due to `Toucha' + 'ble.longPressDelayTimeout` not being cancelled.' || msg === 'Remote debugger is in a background tab which may cause apps to perform slowly. F' + 'ix this by foregrounding the tab (or opening it in a separate window).') {
            return;
          }
        }
        me.logConsole(level, msg); // 多个参数连接成字符串
        oldLoger.apply(console, args);
      };
    }
  }, {
    key: 'logConsole',
    value: function logConsole(level, msg) {
      if (!msg || !msg.message && !msg.stack) {
        return; // 啥也没有就不记录
      }
      var isstring = typeof msg === 'string';
      this.log({
        how: 'log',
        what: isstring ? msg : msg.message,
        level: level,
        stack: !isstring && msg.stack
      });
    }
  }, {
    key: 'startTimer',
    value: function startTimer() {
      if (this.timer) {
        clearTimeout(this.timer);
        this.timer = null;
      }
      this.timer = setTimeout(this.sendLogsNow.bind(this), 5 * 60 * 1000); // 每5分钟发送一次
    }
  }, {
    key: 'sendLogsNow',
    value: function sendLogsNow() {
      if (this.logs.length <= 0) {
        return;
      }
      var data = new Buffer(_lzwcompress2.default.pack(this.logs)).toString('base64');
      this.logs = []; // 日志需要清空，要不会越来越大
      try {
        apis.sendLogs(data);
        console.log((0, _internal.tx)('Saved'));
      } catch (err) {
        console.log((0, _internal.tx)('SaveFail'));
      }
      this.startTimer();
    }
  }, {
    key: 'send',
    value: function send() {
      if (this.logs.length > 100) {
        this.sendLogsNow();
        return true;
      }
      return false;
    }

    // 几点几分谁在哪做了什么

  }, {
    key: 'log',
    value: function log(_ref) {
      var when = _ref.when,
          who = _ref.who,
          where = _ref.where,
          how = _ref.how,
          what = _ref.what,
          other = (0, _objectWithoutProperties3.default)(_ref, ['when', 'who', 'where', 'how', 'what']);

      var store = _Router2.default.getStore();
      var module = store.currentBundle || {};
      var scene = store.currentScene || {};
      var user = _User2.default.getStore().user || {};
      this.logs.push({
        id: _Device2.default.uniqueID,
        when: when || new Date().getTime(),
        who: who || user.name,
        where: where || scene.name,
        how: how,
        what: what,
        data: (0, _extends3.default)({
          module: module.name,
          version: module.version
        }, other)
      });
      this.send();
    }
  }]);
  return Statistics;
}();
//import {Buffer} from 'buffer';


exports.default = new Statistics();
//# sourceMappingURL=Statistics.js.map