'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tx = undefined;
exports.trimEnd = trimEnd;
exports.fixStart = fixStart;

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _I18n = require('../core/I18n');

var _I18n2 = _interopRequireDefault(_I18n);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var coreCommonLoadLang = void 0;

var tx = exports.tx = function tx(key) {
  // 如果切换了语言或者没有加载过，加载一次
  if (coreCommonLoadLang !== _I18n2.default.language) {
    _I18n2.default.loadNamespaces(['core.common']);
    coreCommonLoadLang = _I18n2.default.language;
  }
  return _I18n2.default.tx('core.common', key);
};

function trimEnd(txt, trimTxt) {
  (0, _assert2.default)(txt);
  (0, _assert2.default)(trimTxt);
  if (txt.endsWith(trimTxt)) {
    return txt.substr(0, txt.length - 1);
  }
  return txt;
}

function fixStart(txt, fixTxt) {
  (0, _assert2.default)(txt);
  (0, _assert2.default)(fixTxt);
  return txt.startsWith(fixTxt) ? txt : '' + fixTxt + txt;
}
//# sourceMappingURL=internal.js.map